import { tryOnUnmounted, useDebounceFn, tryOnMounted, useMutationObserver } from "@vueuse/core";
import { Radio, Checkbox, Select, Tree, TreeSelect, Input, InputNumber, AutoComplete, Switch, Cascader, Slider, Rate, DatePicker, TimePicker, Divider, Tooltip, Col, Form, Button, Modal as Modal$1, Row } from "ant-design-vue";
import { getCurrentInstance, shallowRef, reactive, watchEffect, unref, readonly, computed, ref, defineComponent, watch, resolveComponent, openBlock, createBlock, mergeProps, withCtx, createElementBlock, Fragment, renderList, createTextVNode, toDisplayString, createSlots, renderSlot, normalizeProps, guardReactiveProps, createVNode, createElementVNode, normalizeStyle, onMounted, onUnmounted, nextTick, normalizeClass, useSlots, createCommentVNode, toRefs, withDirectives, vShow, isVNode, provide, inject, toRaw, h as h$1, onBeforeUnmount, resolveDynamicComponent, resolveDirective, toRef, withKeys } from "vue";
import { mergeWith, intersectionWith, isEqual, unionWith, omit, get as get$1, cloneDeep, upperFirst, set, uniqBy } from "lodash-es";
import dayjs from "dayjs";
import { LoadingOutlined, InfoCircleOutlined, FullscreenExitOutlined, FullscreenOutlined, CloseOutlined } from "@ant-design/icons-vue";
import Iconify from "@purge-icons/generated";
import ResizeObserver from "resize-observer-polyfill";
const antd = "", DEFAULT_EXCLUDE_KEYS = ["class", "style"], LISTENER_PREFIX = /^on[A-Z]/;
function entries(e) {
  return Object.keys(e).map((k) => [k, e[k]]);
}
function useAttrs(e = {}) {
  const k = getCurrentInstance();
  if (!k)
    return {};
  const {
    excludeListeners: W = !1,
    excludeKeys: H = [],
    excludeDefaultKeys: U = !0
  } = e, K = shallowRef({}), G = H.concat(
    U ? DEFAULT_EXCLUDE_KEYS : []
  );
  return k.attrs = reactive(k.attrs), watchEffect(() => {
    const Z = entries(k.attrs).reduce((X, [Q, te]) => (!G.includes(Q) && !(W && LISTENER_PREFIX.test(Q)) && (X[Q] = te), X), {});
    K.value = Z;
  }), K;
}
/*!
 * is-plain-object <https://github.com/jonschlinkert/is-plain-object>
 *
 * Copyright (c) 2014-2017, Jon Schlinkert.
 * Released under the MIT License.
 */
function isObject$1(e) {
  return Object.prototype.toString.call(e) === "[object Object]";
}
function isPlainObject(e) {
  var k, W;
  return isObject$1(e) === !1 ? !1 : (k = e.constructor, k === void 0 ? !0 : (W = k.prototype, !(isObject$1(W) === !1 || W.hasOwnProperty("isPrototypeOf") === !1)));
}
function t$2() {
  return t$2 = Object.assign ? Object.assign.bind() : function(e) {
    for (var k = 1; k < arguments.length; k++) {
      var W = arguments[k];
      for (var H in W)
        Object.prototype.hasOwnProperty.call(W, H) && (e[H] = W[H]);
    }
    return e;
  }, t$2.apply(this, arguments);
}
function r(e, k) {
  if (e == null)
    return {};
  var W, H, U = {}, K = Object.keys(e);
  for (H = 0; H < K.length; H++)
    k.indexOf(W = K[H]) >= 0 || (U[W] = e[W]);
  return U;
}
const n = { silent: !1, logLevel: "warn" }, i = ["validator"], o = Object.prototype, a = o.toString, s = o.hasOwnProperty, u = /^\s*function (\w+)/;
function l(e) {
  var k;
  const W = (k = e == null ? void 0 : e.type) !== null && k !== void 0 ? k : e;
  if (W) {
    const H = W.toString().match(u);
    return H ? H[1] : "";
  }
  return "";
}
const c = isPlainObject, f = (e) => e;
let d = f;
process.env.NODE_ENV !== "production" && (d = typeof console < "u" ? function(k, W = n.logLevel) {
  n.silent === !1 && console[W](`[VueTypes warn]: ${k}`);
} : f);
const p = (e, k) => s.call(e, k), y = Number.isInteger || function(e) {
  return typeof e == "number" && isFinite(e) && Math.floor(e) === e;
}, v = Array.isArray || function(e) {
  return a.call(e) === "[object Array]";
}, h = (e) => a.call(e) === "[object Function]", b = (e) => c(e) && p(e, "_vueTypes_name"), g = (e) => c(e) && (p(e, "type") || ["_vueTypes_name", "validator", "default", "required"].some((k) => p(e, k)));
function O(e, k) {
  return Object.defineProperty(e.bind(k), "__original", { value: e });
}
function m(e, k, W = !1) {
  let H, U = !0, K = "";
  H = c(e) ? e : { type: e };
  const G = b(H) ? H._vueTypes_name + " - " : "";
  if (g(H) && H.type !== null) {
    if (H.type === void 0 || H.type === !0 || !H.required && k === void 0)
      return U;
    v(H.type) ? (U = H.type.some((Z) => m(Z, k, !0) === !0), K = H.type.map((Z) => l(Z)).join(" or ")) : (K = l(H), U = K === "Array" ? v(k) : K === "Object" ? c(k) : K === "String" || K === "Number" || K === "Boolean" || K === "Function" ? function(Z) {
      if (Z == null)
        return "";
      const X = Z.constructor.toString().match(u);
      return X ? X[1] : "";
    }(k) === K : k instanceof H.type);
  }
  if (!U) {
    const Z = `${G}value "${k}" should be of type "${K}"`;
    return W === !1 ? (d(Z), !1) : Z;
  }
  if (p(H, "validator") && h(H.validator)) {
    const Z = d, X = [];
    if (d = (Q) => {
      X.push(Q);
    }, U = H.validator(k), d = Z, !U) {
      const Q = (X.length > 1 ? "* " : "") + X.join(`
* `);
      return X.length = 0, W === !1 ? (d(Q), U) : Q;
    }
  }
  return U;
}
function j(e, k) {
  const W = Object.defineProperties(k, { _vueTypes_name: { value: e, writable: !0 }, isRequired: { get() {
    return this.required = !0, this;
  } }, def: { value(U) {
    return U === void 0 ? (p(this, "default") && delete this.default, this) : h(U) || m(this, U, !0) === !0 ? (this.default = v(U) ? () => [...U] : c(U) ? () => Object.assign({}, U) : U, this) : (d(`${this._vueTypes_name} - invalid default value: "${U}"`), this);
  } } }), { validator: H } = W;
  return h(H) && (W.validator = O(H, W)), W;
}
function _(e, k) {
  const W = j(e, k);
  return Object.defineProperty(W, "validate", { value(H) {
    return h(this.validator) && d(`${this._vueTypes_name} - calling .validate() will overwrite the current custom validator function. Validator info:
${JSON.stringify(this)}`), this.validator = O(H, this), this;
  } });
}
function T(e, k, W) {
  const H = function(X) {
    const Q = {};
    return Object.getOwnPropertyNames(X).forEach((te) => {
      Q[te] = Object.getOwnPropertyDescriptor(X, te);
    }), Object.defineProperties({}, Q);
  }(k);
  if (H._vueTypes_name = e, !c(W))
    return H;
  const { validator: U } = W, K = r(W, i);
  if (h(U)) {
    let { validator: X } = H;
    X && (X = (Z = (G = X).__original) !== null && Z !== void 0 ? Z : G), H.validator = O(X ? function(Q) {
      return X.call(this, Q) && U.call(this, Q);
    } : U, H);
  }
  var G, Z;
  return Object.assign(H, K);
}
function $(e) {
  return e.replace(/^(?!\s*$)/gm, "  ");
}
const w = () => _("any", {}), P = () => _("function", { type: Function }), x = () => _("boolean", { type: Boolean }), E = () => _("string", { type: String }), N = () => _("number", { type: Number }), q = () => _("array", { type: Array }), A = () => _("object", { type: Object }), V = () => j("integer", { type: Number, validator: (e) => y(e) }), S = () => j("symbol", { validator: (e) => typeof e == "symbol" });
function D(e, k = "custom validation failed") {
  if (typeof e != "function")
    throw new TypeError("[VueTypes error]: You must provide a function as argument");
  return j(e.name || "<<anonymous function>>", { type: null, validator(W) {
    const H = e(W);
    return H || d(`${this._vueTypes_name} - ${k}`), H;
  } });
}
function L(e) {
  if (!v(e))
    throw new TypeError("[VueTypes error]: You must provide an array as argument.");
  const k = `oneOf - value should be one of "${e.join('", "')}".`, W = e.reduce((H, U) => {
    if (U != null) {
      const K = U.constructor;
      H.indexOf(K) === -1 && H.push(K);
    }
    return H;
  }, []);
  return j("oneOf", { type: W.length > 0 ? W : void 0, validator(H) {
    const U = e.indexOf(H) !== -1;
    return U || d(k), U;
  } });
}
function F(e) {
  if (!v(e))
    throw new TypeError("[VueTypes error]: You must provide an array as argument");
  let k = !1, W = [];
  for (let U = 0; U < e.length; U += 1) {
    const K = e[U];
    if (g(K)) {
      if (b(K) && K._vueTypes_name === "oneOf" && K.type) {
        W = W.concat(K.type);
        continue;
      }
      if (h(K.validator) && (k = !0), K.type === !0 || !K.type) {
        d('oneOfType - invalid usage of "true" or "null" as types.');
        continue;
      }
      W = W.concat(K.type);
    } else
      W.push(K);
  }
  W = W.filter((U, K) => W.indexOf(U) === K);
  const H = W.length > 0 ? W : null;
  return j("oneOfType", k ? { type: H, validator(U) {
    const K = [], G = e.some((Z) => {
      const X = m(b(Z) && Z._vueTypes_name === "oneOf" ? Z.type || null : Z, U, !0);
      return typeof X == "string" && K.push(X), X === !0;
    });
    return G || d(`oneOfType - provided value does not match any of the ${K.length} passed-in validators:
${$(K.join(`
`))}`), G;
  } } : { type: H });
}
function Y(e) {
  return j("arrayOf", { type: Array, validator(k) {
    let W = "";
    const H = k.every((U) => (W = m(e, U, !0), W === !0));
    return H || d(`arrayOf - value validation error:
${$(W)}`), H;
  } });
}
function B(e) {
  return j("instanceOf", { type: e });
}
function I(e) {
  return j("objectOf", { type: Object, validator(k) {
    let W = "";
    const H = Object.keys(k).every((U) => (W = m(e, k[U], !0), W === !0));
    return H || d(`objectOf - value validation error:
${$(W)}`), H;
  } });
}
function J(e) {
  const k = Object.keys(e), W = k.filter((U) => {
    var K;
    return !((K = e[U]) === null || K === void 0 || !K.required);
  }), H = j("shape", { type: Object, validator(U) {
    if (!c(U))
      return !1;
    const K = Object.keys(U);
    if (W.length > 0 && W.some((G) => K.indexOf(G) === -1)) {
      const G = W.filter((Z) => K.indexOf(Z) === -1);
      return d(G.length === 1 ? `shape - required property "${G[0]}" is not defined.` : `shape - required properties "${G.join('", "')}" are not defined.`), !1;
    }
    return K.every((G) => {
      if (k.indexOf(G) === -1)
        return this._vueTypes_isLoose === !0 || (d(`shape - shape definition does not include a "${G}" property. Allowed keys: "${k.join('", "')}".`), !1);
      const Z = m(e[G], U[G], !0);
      return typeof Z == "string" && d(`shape - "${G}" property validation error:
 ${$(Z)}`), Z === !0;
    });
  } });
  return Object.defineProperty(H, "_vueTypes_isLoose", { writable: !0, value: !1 }), Object.defineProperty(H, "loose", { get() {
    return this._vueTypes_isLoose = !0, this;
  } }), H;
}
const M = ["name", "validate", "getter"], R = /* @__PURE__ */ (() => {
  var e;
  return (e = class {
    static get any() {
      return w();
    }
    static get func() {
      return P().def(this.defaults.func);
    }
    static get bool() {
      return x().def(this.defaults.bool);
    }
    static get string() {
      return E().def(this.defaults.string);
    }
    static get number() {
      return N().def(this.defaults.number);
    }
    static get array() {
      return q().def(this.defaults.array);
    }
    static get object() {
      return A().def(this.defaults.object);
    }
    static get integer() {
      return V().def(this.defaults.integer);
    }
    static get symbol() {
      return S();
    }
    static get nullable() {
      return { type: null };
    }
    static extend(k) {
      if (v(k))
        return k.forEach((X) => this.extend(X)), this;
      const { name: W, validate: H = !1, getter: U = !1 } = k, K = r(k, M);
      if (p(this, W))
        throw new TypeError(`[VueTypes error]: Type "${W}" already defined`);
      const { type: G } = K;
      if (b(G))
        return delete K.type, Object.defineProperty(this, W, U ? { get: () => T(W, G, K) } : { value(...X) {
          const Q = T(W, G, K);
          return Q.validator && (Q.validator = Q.validator.bind(Q, ...X)), Q;
        } });
      let Z;
      return Z = U ? { get() {
        const X = Object.assign({}, K);
        return H ? _(W, X) : j(W, X);
      }, enumerable: !0 } : { value(...X) {
        const Q = Object.assign({}, K);
        let te;
        return te = H ? _(W, Q) : j(W, Q), Q.validator && (te.validator = Q.validator.bind(te, ...X)), te;
      }, enumerable: !0 }, Object.defineProperty(this, W, Z);
    }
  }).defaults = {}, e.sensibleDefaults = void 0, e.config = n, e.custom = D, e.oneOf = L, e.instanceOf = B, e.oneOfType = F, e.arrayOf = Y, e.objectOf = I, e.shape = J, e.utils = { validate: (k, W) => m(W, k, !0) === !0, toType: (k, W, H = !1) => H ? _(k, W) : j(k, W) }, e;
})();
function z(e = { func: () => {
}, bool: !0, string: "", number: 0, array: () => [], object: () => ({}), integer: 0 }) {
  var k;
  return (k = class extends R {
    static get sensibleDefaults() {
      return t$2({}, this.defaults);
    }
    static set sensibleDefaults(W) {
      this.defaults = W !== !1 ? t$2({}, W !== !0 ? W : e) : {};
    }
  }).defaults = t$2({}, e), k;
}
class C extends z() {
}
const propTypes = z({
  func: void 0,
  bool: void 0,
  string: void 0,
  number: void 0,
  object: void 0,
  integer: void 0
});
propTypes.extend([
  {
    name: "style",
    getter: !0,
    type: [String, Object],
    default: void 0
  },
  {
    name: "VNodeChild",
    getter: !0,
    type: void 0
  }
]);
const prefix = "G", toString = Object.prototype.toString;
function is(e, k) {
  return toString.call(e) === `[object ${k}]`;
}
function isNumber(e) {
  return is(e, "Number");
}
function isString(e) {
  return is(e, "String");
}
function isBoolean(e) {
  return is(e, "Boolean");
}
function isArray(e) {
  return e && Array.isArray(e);
}
function isObject(e) {
  return e !== null && is(e, "Object");
}
function isFunction(e) {
  return typeof e == "function";
}
const isNull = (e) => e === null;
function isDef(e) {
  return typeof e < "u";
}
function isUnDef(e) {
  return !isDef(e);
}
function isNullOrUnDef(e) {
  return isUnDef(e) || isNull(e);
}
function deepMerge(e, k, W = "replace") {
  return k ? e ? mergeWith({}, e, k, (H, U) => {
    if (isArray(U) && isArray(H))
      switch (W) {
        case "union":
          return unionWith(H, U, isEqual);
        case "intersection":
          return intersectionWith(H, U, isEqual);
        case "concat":
          return H.concat(U);
        case "replace":
          return U;
        default:
          throw new Error(
            `Unknown merge array strategy: ${W}`
          );
      }
    if (isObject(U) && isObject(H))
      return deepMerge(H, U, W);
  }) : k : e;
}
function getSlot(e, k = "default", W, H) {
  if (!e || !Reflect.has(e, k))
    return null;
  if (!isFunction(e[k]))
    return console.error(`${k} is not a function!`), null;
  const U = e[k];
  if (!U)
    return null;
  const K = {
    ...W,
    ...H
  };
  return U(K);
}
function extendSlots(e, k = []) {
  const W = Object.keys(e), H = {};
  return W.map((U) => {
    if (k.includes(U))
      return null;
    H[U] = (K) => getSlot(e, U, K);
  }), H;
}
const projectName = "gopher-gui";
function error(e) {
  throw new Error(`[${projectName} error]:${e}`);
}
function on(e, k, W) {
  e && k && W && e.addEventListener(k, W, !1);
}
function off(e, k, W) {
  e && k && W && e.removeEventListener(k, W, !1);
}
const dateUtil = dayjs;
for (let e = 0; e <= 15; e++)
  e.toString(16);
function deepMergeObject(e = {}, k = {}) {
  let W;
  for (W in k)
    e[W] = isObject(e[W]) ? deepMergeObject(e[W], k[W]) : e[W] = k[W];
  return e;
}
function getDynamicProps(e) {
  const k = {};
  return Object.keys(e).map((W) => {
    k[W] = unref(e[W]);
  }), k;
}
function useRuleFormItem(e, k = "value", W = "change", H) {
  const U = getCurrentInstance();
  U == null || U.emit;
  const K = reactive({
    value: e[k]
  }), G = readonly(K), Z = (Q) => {
    K.value = Q;
  };
  return watchEffect(() => {
    K.value = e[k];
  }), [computed({
    get() {
      return K.value;
    },
    set(Q) {
      isEqual(Q, G.value) || (K.value = Q);
    }
  }), Z, G];
}
const en = {
  pagination: {
    totalItemText: "Total",
    goToText: "Go to"
  },
  accordion: {
    loading: "loading",
    noData: "No Data"
  },
  autoCompleteDropdown: {
    latestInput: "Latest input"
  },
  cascaderList: {
    noData: "No data"
  },
  colorPicker: {
    foundationPanel: "Foundation panel",
    advancedPanel: "Advanced panel"
  },
  datePickerPro: {
    ok: "OK",
    placeholder: "select date",
    month1: "Jan",
    month2: "Feb",
    month3: "Mar",
    month4: "Apr",
    month5: "May",
    month6: "June",
    month7: "July",
    month8: "Aug",
    month9: "Sep",
    month10: "Oct",
    month11: "Nov",
    month12: "Dec",
    year: "年",
    startPlaceholder: "select start date",
    endPlaceholder: "select end date",
    getWeekDays() {
      return ["Sun", "Mon", "Tue", "Wed", "Thur", "Fri", "Sat"];
    },
    getTimeArr() {
      return ["Hr", "Min", "Sec"];
    },
    getYearMonthStr(e, k) {
      return `${e} - ${k}`;
    }
  },
  editableSelect: {
    noRelatedRecords: "No related records found",
    noData: "No data"
  },
  input: {
    placeholder: "Please enter"
  },
  splitterBar: {
    collapse: "Collapse",
    expand: "Expand"
  },
  stepsGuide: {
    previous: "Previous",
    continue: "Continue",
    ok: "OK"
  },
  table: {
    selectAll: "Select all",
    ok: "OK"
  },
  timePopup: {
    ok: "OK"
  },
  transfer: {
    unit: "",
    panelUnit: "",
    headerUnit: "",
    noData: "No Data",
    placeholder: "Please enter keywords"
  },
  tree: {
    loading: "Loading",
    newNode: "New node",
    selectPlaceholder: "Please select"
  },
  upload: {
    save: "Save",
    upload: "Upload",
    imgUpload: "ImageUpload",
    uploaded: "Uploaded",
    operating: "Operating",
    del: "Delete",
    download: "download",
    saveWarn: "Please wait for the file to upload and save!",
    saveError: "There is no file successfully uploaded and cannot be saved!",
    preview: "Preview",
    choose: "Select the file",
    accept: "Support {0} format",
    acceptUpload: "Only upload files in {0} format",
    maxSize: "A single file does not exceed {0}MB ",
    maxSizeMultiple: "Only upload files up to {0}MB!",
    maxNumber: "Only upload up to {0} files",
    legend: "Legend",
    fileName: "File name",
    fileSize: "File size",
    fileStatue: "File status",
    startUpload: "Start upload",
    uploadSuccess: "Upload successfully",
    uploadError: "Upload failed",
    uploading: "Uploading",
    uploadWait: "Please wait for the file upload to finish",
    reUploadFailed: "Re-upload failed files",
    noFile: "The file does not exist!"
  },
  search: {
    placeholder: "Enter a keyword"
  },
  select: {
    placeholder: "Please select",
    noDataText: "No data",
    noMatchText: "No related records found",
    loadingText: "Loading..."
  },
  tagInput: {
    maxTagsText: "Maximum number reached: "
  },
  timeSelect: {
    placeholder: "Please select time"
  },
  modal: {
    cancelText: "Close",
    okText: "Confirm",
    close: "Close",
    maximize: "Maximize",
    restore: "Restore"
  },
  excel: {
    exportModalTitle: "Export data",
    fileType: "File type",
    fileName: "File name"
  },
  form: {
    putAway: "Put away",
    unfold: "Unfold",
    maxTip: "The number of characters should be less than {0}",
    apiSelectNotFound: "Wait for data loading to complete..."
  },
  previewFile: {
    notSupport: "The file does not support preview",
    download: "download"
  },
  signature: {
    deleteSelectedSignature: "Delete selected signature",
    deleteAllSignature: "Delete all signatures",
    page: "page",
    jumpTo: "jump to",
    dragTip: "Please select the following signature and drag it to the left file",
    selectTip: "Please select the signature",
    smallTip: "The signature can't be any smaller",
    deleteTip: "Please select the signature you want to delete",
    addSignature: "Add Signature"
  },
  common: {
    preview: "Preview",
    download: "Download",
    okText: "OK",
    closeText: "Close",
    cancelText: "Cancel",
    loadingText: "Loading...",
    saveText: "Save",
    submitText: "Submit",
    delText: "Delete",
    resetText: "Reset",
    searchText: "Search",
    queryText: "Search",
    inputText: "Please enter",
    chooseText: "Please choose",
    redo: "Refresh",
    back: "Back",
    light: "Light",
    dark: "Dark",
    zoomIn: "Zoom In",
    zoomOut: "Zoom Out",
    reset: "reset",
    enterFullScreen: "Full Screen",
    exitFullScreen: "Exit Full Screen"
  }
}, __vite_glob_0_0 = /* @__PURE__ */ Object.freeze(/* @__PURE__ */ Object.defineProperty({
  __proto__: null,
  default: en
}, Symbol.toStringTag, { value: "Module" })), zh_cn = {
  pagination: {
    totalItemText: "所有条目",
    goToText: "跳至",
    perPage: "条/页"
  },
  accordion: {
    loading: "加载中",
    noData: "没有数据"
  },
  autoCompleteDropdown: {
    latestInput: "最近输入"
  },
  cascaderList: {
    noData: "没有数据"
  },
  colorPicker: {
    foundationPanel: "基础面板",
    advancedPanel: "高级面板"
  },
  datePickerPro: {
    ok: "确定",
    placeholder: "请选择日期",
    month1: "1月",
    month2: "2月",
    month3: "3月",
    month4: "4月",
    month5: "5月",
    month6: "6月",
    month7: "7月",
    month8: "8月",
    month9: "9月",
    month10: "10月",
    month11: "11月",
    month12: "12月",
    year: "年",
    startPlaceholder: "请选择开始日期",
    endPlaceholder: "请选择结束日期",
    getWeekDays() {
      return ["日", "一", "二", "三", "四", "五", "六"];
    },
    getTimeArr() {
      return ["时", "分", "秒"];
    },
    getYearMonthStr(e, k) {
      return `${e}年${k}月`;
    }
  },
  editableSelect: {
    noRelatedRecords: "找不到相关记录",
    noData: "没有数据"
  },
  input: {
    placeholder: "请输入"
  },
  splitterBar: {
    collapse: "收起",
    expand: "展开"
  },
  stepsGuide: {
    previous: "上一步",
    continue: "我知道啦，继续",
    ok: "我知道啦"
  },
  table: {
    selectAll: "全选",
    ok: "确定"
  },
  timePopup: {
    ok: "确定"
  },
  transfer: {
    unit: "项",
    panelUnit: "项",
    headerUnit: "项",
    noData: "暂无数据",
    placeholder: "请输入关键词搜索"
  },
  tree: {
    loading: "加载中",
    newNode: "新节点",
    selectPlaceholder: "请选择"
  },
  upload: {
    save: "保存",
    upload: "上传",
    imgUpload: "图片上传",
    uploaded: "已上传",
    operating: "操作",
    del: "删除",
    download: "下载",
    saveWarn: "请等待文件上传后，保存!",
    saveError: "没有上传成功的文件，无法保存!",
    preview: "预览",
    choose: "选择文件",
    accept: "支持{0}格式",
    acceptUpload: "只能上传{0}格式文件",
    maxSize: "单个文件不超过{0}MB",
    maxSizeMultiple: "只能上传不超过{0}MB的文件!",
    maxNumber: "最多只能上传{0}个文件",
    legend: "略缩图",
    fileName: "文件名",
    fileSize: "文件大小",
    fileStatue: "状态",
    startUpload: "开始上传",
    uploadSuccess: "上传成功",
    uploadError: "上传失败",
    uploading: "上传中",
    uploadWait: "请等待文件上传结束后操作",
    reUploadFailed: "重新上传失败文件",
    import: "导入",
    startImport: "开始导入",
    importing: "导入中",
    reImportFailed: "重新导入失败文件",
    noFile: "文件不存在！"
  },
  search: {
    placeholder: "请输入关键字"
  },
  select: {
    placeholder: "请选择",
    noDataText: "无数据",
    noMatchText: "找不到相关记录",
    loadingText: "加载中..."
  },
  tagInput: {
    maxTagsText: "已达到最大个数："
  },
  timeSelect: {
    placeholder: "请选择时间"
  },
  modal: {
    cancelText: "关闭",
    okText: "确认",
    close: "关闭",
    maximize: "最大化",
    restore: "还原"
  },
  excel: {
    exportModalTitle: "导出数据",
    fileType: "文件类型",
    fileName: "文件名"
  },
  form: {
    putAway: "收起",
    unfold: "展开",
    maxTip: "字符数应小于{0}位",
    apiSelectNotFound: "请等待数据加载完成..."
  },
  previewFile: {
    notSupport: "该文件不支持预览",
    download: "下载"
  },
  signature: {
    deleteSelectedSignature: "删除选中签名",
    deleteAllSignature: "删除全部签名",
    page: "页",
    jumpTo: "跳至",
    dragTip: "请选择以下签名并将其拖到左侧文件",
    selectTip: "请选择签名",
    smallTip: "已经最小了",
    deleteTip: "请选中你要删除的签名",
    addSignature: "新建电子签章"
  },
  common: {
    preview: "预览",
    download: "下载",
    okText: "确认",
    closeText: "关闭",
    cancelText: "取消",
    loadingText: "加载中...",
    saveText: "保存",
    submitText: "提交",
    delText: "删除",
    resetText: "重置",
    searchText: "搜索",
    queryText: "查询",
    inputText: "请输入",
    chooseText: "请选择",
    redo: "刷新",
    back: "返回",
    light: "亮色主题",
    dark: "黑暗主题",
    zoomIn: "放大",
    zoomOut: "缩小",
    reset: "还原",
    enterFullScreen: "全屏",
    exitFullScreen: "退出全屏"
  }
}, __vite_glob_0_1 = /* @__PURE__ */ Object.freeze(/* @__PURE__ */ Object.defineProperty({
  __proto__: null,
  default: zh_cn
}, Symbol.toStringTag, { value: "Module" })), modules = /* @__PURE__ */ Object.assign({ "./lang/en.ts": __vite_glob_0_0, "./lang/zh_cn.ts": __vite_glob_0_1 }), langMessages = {};
Object.keys(modules).forEach((e) => {
  const k = modules[e].default || {};
  langMessages[e] = k;
});
const lang = ref("zh_cn"), useCustomLocale = () => {
  const e = reactive({
    langMessages
  }), k = () => lang.value.toLocaleLowerCase();
  return {
    getLang: k,
    setLang: (U) => {
      lang.value = U;
    },
    getMessages: () => {
      const U = `./lang/${k()}.ts`;
      return e.langMessages[U];
    }
  };
};
function get(e, k) {
  const W = k.split(".");
  let H = e;
  return W.forEach((U) => {
    H = H[U] ?? "";
  }), H;
}
function useI18n() {
  return (e) => {
    const k = useCustomLocale().getMessages();
    return get(k, e);
  };
}
const _sfc_main$o = defineComponent({
  name: "ApiRadioGroup",
  components: {
    RadioGroup: Radio.Group,
    RadioButton: Radio.Button,
    Radio
  },
  props: {
    api: {
      type: Function,
      default: null
    },
    params: {
      type: [Object, String],
      default: () => ({})
    },
    value: {
      type: [String, Number, Boolean]
    },
    isBtn: {
      type: [Boolean],
      default: !1
    },
    numberToString: propTypes.bool,
    resultField: propTypes.string.def(""),
    labelField: propTypes.string.def("label"),
    valueField: propTypes.string.def("value"),
    immediate: propTypes.bool.def(!0)
  },
  emits: ["options-change", "change"],
  setup(e, { emit: k }) {
    const W = ref([]), H = ref(!1), U = ref(!0), K = ref([]), G = useAttrs(), Z = useI18n(), [X] = useRuleFormItem(e), Q = computed(() => {
      const { labelField: ie, valueField: ee, numberToString: ne } = e;
      return unref(W).reduce((se, le) => {
        if (le) {
          const ae = le[ee];
          se.push({
            label: le[ie],
            value: ne ? `${ae}` : ae,
            ...omit(le, [ie, ee])
          });
        }
        return se;
      }, []);
    });
    watchEffect(() => {
      e.immediate && te();
    }), watch(
      () => e.params,
      () => {
        !unref(U) && te();
      },
      { deep: !0 }
    );
    async function te() {
      const ie = e.api;
      if (!(!ie || !isFunction(ie))) {
        W.value = [];
        try {
          H.value = !0;
          const ee = await ie(e.params);
          if (Array.isArray(ee)) {
            W.value = ee, re();
            return;
          }
          e.resultField && (W.value = get$1(ee, e.resultField) || []), re();
        } catch (ee) {
          console.warn(ee);
        } finally {
          H.value = !1;
        }
      }
    }
    function re() {
      k("options-change", unref(Q));
    }
    function oe(ie, ...ee) {
      K.value = ee;
    }
    return { state: X, getOptions: Q, attrs: G, loading: H, t: Z, handleChange: oe, props: e };
  }
}), _export_sfc = (e, k) => {
  const W = e.__vccOpts || e;
  for (const [H, U] of k)
    W[H] = U;
  return W;
};
function _sfc_render$j(e, k, W, H, U, K) {
  const G = resolveComponent("RadioButton"), Z = resolveComponent("Radio"), X = resolveComponent("RadioGroup");
  return openBlock(), createBlock(X, mergeProps(e.attrs, {
    value: e.state,
    "onUpdate:value": k[0] || (k[0] = (Q) => e.state = Q),
    "button-style": "solid",
    onChange: e.handleChange
  }), {
    default: withCtx(() => [
      (openBlock(!0), createElementBlock(Fragment, null, renderList(e.getOptions, (Q) => (openBlock(), createElementBlock(Fragment, {
        key: `${Q.value}`
      }, [
        e.props.isBtn ? (openBlock(), createBlock(G, {
          key: 0,
          value: Q.value,
          disabled: Q.disabled
        }, {
          default: withCtx(() => [
            createTextVNode(toDisplayString(Q.label), 1)
          ]),
          _: 2
        }, 1032, ["value", "disabled"])) : (openBlock(), createBlock(Z, {
          key: 1,
          value: Q.value,
          disabled: Q.disabled
        }, {
          default: withCtx(() => [
            createTextVNode(toDisplayString(Q.label), 1)
          ]),
          _: 2
        }, 1032, ["value", "disabled"]))
      ], 64))), 128))
    ]),
    _: 1
  }, 16, ["value", "onChange"]);
}
const ApiRadioGroup = /* @__PURE__ */ _export_sfc(_sfc_main$o, [["render", _sfc_render$j]]), _sfc_main$n = defineComponent({
  name: "ApiCheckboxGroup",
  components: {
    CheckboxGroup: Checkbox.Group,
    Checkbox
  },
  props: {
    api: {
      type: Function,
      default: null
    },
    params: {
      type: [Object, String],
      default: () => ({})
    },
    value: {
      type: [String, Number, Boolean]
    },
    isBtn: {
      type: [Boolean],
      default: !1
    },
    numberToString: propTypes.bool,
    resultField: propTypes.string.def(""),
    labelField: propTypes.string.def("label"),
    valueField: propTypes.string.def("value"),
    immediate: propTypes.bool.def(!0)
  },
  emits: ["options-change", "change"],
  setup(e, { emit: k }) {
    const W = ref([]), H = ref(!1), U = ref(!0), K = ref([]), G = useAttrs(), Z = useI18n(), [X] = useRuleFormItem(e), Q = computed(() => {
      const { labelField: ie, valueField: ee, numberToString: ne } = e;
      return unref(W).reduce((se, le) => {
        if (le) {
          const ae = le[ee];
          se.push({
            label: le[ie],
            value: ne ? `${ae}` : ae,
            ...omit(le, [ie, ee])
          });
        }
        return se;
      }, []);
    });
    watchEffect(() => {
      e.immediate && te();
    }), watch(
      () => e.params,
      () => {
        !unref(U) && te();
      },
      { deep: !0 }
    );
    async function te() {
      const ie = e.api;
      if (!(!ie || !isFunction(ie))) {
        W.value = [];
        try {
          H.value = !0;
          const ee = await ie(e.params);
          if (Array.isArray(ee)) {
            W.value = ee, re();
            return;
          }
          e.resultField && (W.value = get$1(ee, e.resultField) || []), re();
        } catch (ee) {
          console.warn(ee);
        } finally {
          H.value = !1;
        }
      }
    }
    function re() {
      k("options-change", unref(Q));
    }
    function oe(ie, ...ee) {
      K.value = ee, k("change", ie, ...ee);
    }
    return { state: X, getOptions: Q, attrs: G, loading: H, t: Z, handleChange: oe, props: e };
  }
});
function _sfc_render$i(e, k, W, H, U, K) {
  const G = resolveComponent("Checkbox"), Z = resolveComponent("CheckboxGroup");
  return openBlock(), createBlock(Z, mergeProps(e.attrs, {
    value: e.state,
    "onUpdate:value": k[0] || (k[0] = (X) => e.state = X),
    "button-style": "solid",
    onChange: e.handleChange
  }), {
    default: withCtx(() => [
      (openBlock(!0), createElementBlock(Fragment, null, renderList(e.getOptions, (X) => (openBlock(), createBlock(G, {
        key: `${X.value}`,
        value: X.value,
        disabled: X.disabled
      }, {
        default: withCtx(() => [
          createTextVNode(toDisplayString(X.label), 1)
        ]),
        _: 2
      }, 1032, ["value", "disabled"]))), 128))
    ]),
    _: 1
  }, 16, ["value", "onChange"]);
}
const ApiCheckboxGroup = /* @__PURE__ */ _export_sfc(_sfc_main$n, [["render", _sfc_render$i]]), _sfc_main$m = defineComponent({
  name: "RadioButtonGroup",
  components: {
    RadioGroup: Radio.Group,
    RadioButton: Radio.Button
  },
  props: {
    value: {
      type: [String, Number, Boolean]
    },
    options: {
      type: Array,
      default: () => []
    }
  },
  setup(e) {
    const k = useAttrs(), [W] = useRuleFormItem(e), H = computed(() => {
      const { options: U } = e;
      return !U || (U == null ? void 0 : U.length) === 0 ? [] : U.some((G) => isString(G)) ? U.map((G) => ({
        label: G,
        value: G
      })) : U;
    });
    return { state: W, getOptions: H, attrs: k };
  }
});
function _sfc_render$h(e, k, W, H, U, K) {
  const G = resolveComponent("RadioButton"), Z = resolveComponent("RadioGroup");
  return openBlock(), createBlock(Z, mergeProps(e.attrs, {
    value: e.state,
    "onUpdate:value": k[0] || (k[0] = (X) => e.state = X),
    "button-style": "solid"
  }), {
    default: withCtx(() => [
      (openBlock(!0), createElementBlock(Fragment, null, renderList(e.getOptions, (X) => (openBlock(), createBlock(G, {
        key: `${X.value}`,
        value: X.value,
        disabled: X.disabled
      }, {
        default: withCtx(() => [
          createTextVNode(toDisplayString(X.label), 1)
        ]),
        _: 2
      }, 1032, ["value", "disabled"]))), 128))
    ]),
    _: 1
  }, 16, ["value"]);
}
const RadioButtonGroup = /* @__PURE__ */ _export_sfc(_sfc_main$m, [["render", _sfc_render$h]]), _sfc_main$l = defineComponent({
  name: "ApiSelect",
  components: {
    Select,
    LoadingOutlined
  },
  inheritAttrs: !1,
  props: {
    value: [Array, Object, String, Number],
    numberToString: propTypes.bool,
    api: {
      type: Function,
      default: null
    },
    // api params
    params: {
      type: Object,
      default: () => ({})
    },
    prefixOption: {
      type: Array,
      default: []
    },
    // support xxx.xxx.xx
    resultField: propTypes.string.def(""),
    labelField: propTypes.string.def("label"),
    valueField: propTypes.string.def("value"),
    immediate: propTypes.bool.def(!0),
    alwaysLoad: propTypes.bool.def(!1)
  },
  emits: ["options-change", "change"],
  setup(e, { emit: k }) {
    const W = ref([]), H = ref(!1), U = ref(!0), K = ref([]), G = useAttrs(), Z = useI18n(), [X] = useRuleFormItem(e, "value", "change"), Q = computed(() => {
      const { labelField: ee, valueField: ne, numberToString: se } = e;
      return unref(W).reduce((le, ae) => {
        if (ae) {
          const de = typeof ae == "string" ? ae : ae[ne];
          le.push({
            ...omit(typeof ae == "string" ? {} : ae, [
              ee,
              ne
            ]),
            label: typeof ae == "string" ? ae : ae[ee],
            value: se ? `${de}` : de
          });
        }
        return le;
      }, []);
    });
    watchEffect(() => {
      e.immediate && !e.alwaysLoad && te();
    }), watch(
      () => e.params,
      () => {
        !unref(U) && te();
      },
      { deep: !0 }
    );
    async function te() {
      const ee = e.api;
      if (!(!ee || !isFunction(ee))) {
        W.value = [];
        try {
          H.value = !0;
          const ne = await ee(e.params);
          if (Array.isArray(ne)) {
            W.value = ne, W.value = e.prefixOption.concat(W.value), oe();
            return;
          }
          e.resultField && (W.value = get$1(ne, e.resultField) || []), W.value = e.prefixOption.concat(W.value), oe();
        } catch (ne) {
          console.warn(ne);
        } finally {
          H.value = !1;
        }
      }
    }
    async function re(ee) {
      ee && (e.alwaysLoad ? await te() : !e.immediate && unref(U) && (await te(), U.value = !1));
    }
    function oe() {
      k("options-change", unref(Q));
    }
    function ie(ee, ...ne) {
      K.value = ne, k("change", ee, ...ne);
    }
    return { state: X, attrs: G, getOptions: Q, loading: H, t: Z, handleFetch: re, handleChange: ie };
  }
});
function _sfc_render$g(e, k, W, H, U, K) {
  const G = resolveComponent("LoadingOutlined"), Z = resolveComponent("Select");
  return openBlock(), createBlock(Z, mergeProps({
    onDropdownVisibleChange: e.handleFetch,
    options: e.getOptions
  }, e.$attrs, {
    onChange: e.handleChange,
    value: e.state,
    "onUpdate:value": k[0] || (k[0] = (X) => e.state = X)
  }), createSlots({ _: 2 }, [
    renderList(Object.keys(e.$slots), (X) => ({
      name: X,
      fn: withCtx((Q) => [
        renderSlot(e.$slots, X, normalizeProps(guardReactiveProps(Q || {})))
      ])
    })),
    e.loading ? {
      name: "suffixIcon",
      fn: withCtx(() => [
        createVNode(G, { spin: "" })
      ]),
      key: "0"
    } : void 0,
    e.loading ? {
      name: "notFoundContent",
      fn: withCtx(() => [
        createElementVNode("span", null, [
          createVNode(G, {
            spin: "",
            class: "mr-1"
          }),
          createTextVNode(" " + toDisplayString(e.t("form.apiSelectNotFound")), 1)
        ])
      ]),
      key: "1"
    } : void 0
  ]), 1040, ["onDropdownVisibleChange", "options", "onChange", "value"]);
}
const ApiSelect = /* @__PURE__ */ _export_sfc(_sfc_main$l, [["render", _sfc_render$g]]), _sfc_main$k = defineComponent({
  name: "ApiSearch",
  components: {
    Select,
    LoadingOutlined
  },
  inheritAttrs: !1,
  props: {
    api: {
      type: Function,
      default: null
    },
    wait: {
      type: Number,
      default: 300
    },
    labelField: propTypes.string.def("label"),
    valueField: propTypes.string.def("value"),
    defaultOptions: {
      type: Array,
      default: () => []
    },
    immediate: propTypes.bool.def(!1),
    notFoundContent: {
      type: String,
      default: null
    }
  },
  emits: ["options-change"],
  setup(e, { emit: k }) {
    const W = ref(e.defaultOptions), H = ref(!1), U = useAttrs();
    let K;
    async function G(Q) {
      var re;
      const te = e == null ? void 0 : e.api;
      if (!(!te || !isFunction(te)))
        try {
          H.value = !0, W.value = await ((re = te(Q)) == null ? void 0 : re.then((oe) => oe == null ? void 0 : oe.map((ie) => ({
            ...ie,
            label: ie[e.labelField],
            value: ie[e.valueField]
          }))));
        } finally {
          H.value = !1;
        }
    }
    const Z = (Q) => Q == null ? void 0 : Q.map((te) => ({
      ...te,
      label: te[e.labelField],
      value: te[e.valueField]
    }));
    async function X(Q) {
      K && (clearTimeout(K), K = null), K = setTimeout(() => G(Q), e.wait || 300);
    }
    return watch(
      () => e.defaultOptions,
      (Q) => {
        W.value = Z(Q) || [];
      },
      {
        deep: !0
      }
    ), watchEffect(() => {
      e.immediate && G("");
    }), { attrs: U, options: W, loading: H, handleSearch: X };
  }
});
function _sfc_render$f(e, k, W, H, U, K) {
  const G = resolveComponent("LoadingOutlined"), Z = resolveComponent("Select");
  return openBlock(), createBlock(Z, mergeProps(e.$attrs, {
    options: e.options,
    "show-search": "",
    "filter-option": !1,
    "not-found-content": e.notFoundContent,
    onSearch: e.handleSearch
  }), createSlots({ _: 2 }, [
    renderList(Object.keys(e.$slots), (X) => ({
      name: X,
      fn: withCtx((Q) => [
        renderSlot(e.$slots, X, normalizeProps(guardReactiveProps(Q || {})))
      ])
    })),
    e.loading ? {
      name: "suffixIcon",
      fn: withCtx(() => [
        createVNode(G, { spin: "" })
      ]),
      key: "0"
    } : void 0
  ]), 1040, ["options", "not-found-content", "onSearch"]);
}
const ApiSearch = /* @__PURE__ */ _export_sfc(_sfc_main$k, [["render", _sfc_render$f]]), _sfc_main$j = defineComponent({
  name: "ApiSelectHighlight",
  components: {
    Select,
    LoadingOutlined
  },
  inheritAttrs: !1,
  props: {
    value: {
      type: Array,
      default: () => []
    },
    highlights: {
      type: Array,
      default: () => []
    },
    options: {
      type: Array,
      default: () => []
    },
    labelField: propTypes.string.def("label"),
    valueField: propTypes.string.def("value")
  },
  emits: ["change", "update:value"],
  setup(e, { emit: k }) {
    const W = ref(!1), H = e.options, U = useAttrs(), K = useI18n(), G = computed(() => {
      const { labelField: X, valueField: Q } = e;
      return unref(H).reduce((te, re) => {
        if (re) {
          const oe = typeof re == "string" ? re : re[Q];
          te.push({
            ...omit(typeof re == "string" ? {} : re, [
              X,
              Q
            ]),
            label: typeof re == "string" ? re : re[X],
            value: oe
          });
        }
        return te;
      }, []);
    });
    return {
      t: K,
      loading: W,
      attrs: U,
      getOptions: G,
      handleChange: (X, Q) => {
        k("change", unref(X), unref(Q)), k("update:value", unref(X));
      }
    };
  }
}), ApiSelectHighlight_vue_vue_type_style_index_0_scoped_ba6bc7c0_lang = "", _hoisted_1$3 = { class: "select-highlight-wrapper" };
function _sfc_render$e(e, k, W, H, U, K) {
  const G = resolveComponent("LoadingOutlined"), Z = resolveComponent("Select");
  return openBlock(), createElementBlock("div", _hoisted_1$3, [
    createVNode(Z, mergeProps({ style: { "min-width": "100px" } }, e.$attrs, {
      onChange: e.handleChange,
      options: e.getOptions,
      showSearch: !0,
      "show-arrow": !0,
      value: e.value,
      allowClear: ""
    }), createSlots({
      option: withCtx((X) => [
        createElementVNode("div", {
          style: normalizeStyle({
            color: e.highlights.includes(X.label) ? "#0084f4" : "inherit"
          })
        }, toDisplayString(X.label), 5)
      ]),
      _: 2
    }, [
      renderList(Object.keys(e.$slots), (X) => ({
        name: X,
        fn: withCtx((Q) => [
          renderSlot(e.$slots, X, normalizeProps(guardReactiveProps(Q || {})), void 0, !0)
        ])
      })),
      e.loading ? {
        name: "suffixIcon",
        fn: withCtx(() => [
          createVNode(G, { spin: "" })
        ]),
        key: "0"
      } : void 0,
      e.loading ? {
        name: "notFoundContent",
        fn: withCtx(() => [
          createElementVNode("span", null, [
            createVNode(G, {
              spin: "",
              class: "mr-1"
            }),
            createTextVNode(" " + toDisplayString(e.t("form.apiSelectNotFound")), 1)
          ])
        ]),
        key: "1"
      } : void 0
    ]), 1040, ["onChange", "options", "value"])
  ]);
}
const ApiSelectHighlight = /* @__PURE__ */ _export_sfc(_sfc_main$j, [["render", _sfc_render$e], ["__scopeId", "data-v-ba6bc7c0"]]), _sfc_main$i = defineComponent({
  name: "ApiTree",
  components: { Tree, LoadingOutlined },
  props: {
    api: {
      type: Function
    },
    params: { type: Object },
    immediate: { type: Boolean, default: !0 },
    resultField: propTypes.string.def(""),
    afterFetch: { type: Function }
  },
  emits: ["options-change", "change"],
  setup(e, { attrs: k, emit: W }) {
    const H = ref([]), U = ref(!1), K = ref(!1), G = computed(() => ({
      ...e.api ? { treeData: unref(H) } : {},
      ...k
    }));
    function Z(...Q) {
      W("change", ...Q);
    }
    watch(
      () => e.params,
      () => {
        !unref(U) && X();
      },
      { deep: !0 }
    ), watch(
      () => e.immediate,
      (Q) => {
        Q && !U.value && X();
      }
    ), onMounted(() => {
      e.immediate && X();
    });
    async function X() {
      const { api: Q, afterFetch: te } = e;
      if (!Q || !isFunction(Q))
        return;
      K.value = !0, H.value = [];
      let re;
      try {
        re = await Q(e.params);
      } catch (oe) {
        console.error(oe);
      }
      te && isFunction(te) && (re = te(re)), K.value = !1, re && (isArray(re) || (re = get$1(re, e.resultField)), H.value = re || [], U.value = !0, W("options-change", H.value));
    }
    return { getAttrs: G, loading: K, handleChange: Z };
  }
});
function _sfc_render$d(e, k, W, H, U, K) {
  const G = resolveComponent("LoadingOutlined"), Z = resolveComponent("Tree");
  return openBlock(), createBlock(Z, mergeProps(e.getAttrs, { onChange: e.handleChange }), createSlots({ _: 2 }, [
    renderList(Object.keys(e.$slots), (X) => ({
      name: X,
      fn: withCtx((Q) => [
        renderSlot(e.$slots, X, normalizeProps(guardReactiveProps(Q || {})))
      ])
    })),
    e.loading ? {
      name: "suffixIcon",
      fn: withCtx(() => [
        createVNode(G, { spin: "" })
      ]),
      key: "0"
    } : void 0
  ]), 1040, ["onChange"]);
}
const ApiTree = /* @__PURE__ */ _export_sfc(_sfc_main$i, [["render", _sfc_render$d]]), _sfc_main$h = defineComponent({
  name: "ApiTreeSelect",
  components: { TreeSelect, LoadingOutlined },
  props: {
    api: {
      type: Function
    },
    params: { type: Object },
    immediate: { type: Boolean, default: !0 },
    resultField: propTypes.string.def("")
  },
  emits: ["options-change", "change"],
  setup(e, { attrs: k, emit: W }) {
    const H = ref([]), U = ref(!1), K = ref(!1), G = computed(() => ({
      ...e.api ? { treeData: unref(H) } : {},
      ...k
    }));
    function Z(...Q) {
      W("change", ...Q);
    }
    watch(
      () => e.params,
      () => {
        !unref(U) && X();
      },
      { deep: !0 }
    ), watch(
      () => e.immediate,
      (Q) => {
        Q && !U.value && X();
      }
    ), onMounted(() => {
      e.immediate && X();
    });
    async function X() {
      const { api: Q } = e;
      if (!Q || !isFunction(Q))
        return;
      K.value = !0, H.value = [];
      let te;
      try {
        te = await Q(e.params);
      } catch (re) {
        console.error(re);
      }
      K.value = !1, te && (isArray(te) || (te = get$1(te, e.resultField)), H.value = te || [], U.value = !0, W("options-change", H.value));
    }
    return { getAttrs: G, loading: K, handleChange: Z };
  }
});
function _sfc_render$c(e, k, W, H, U, K) {
  const G = resolveComponent("LoadingOutlined"), Z = resolveComponent("TreeSelect");
  return openBlock(), createBlock(Z, mergeProps(e.getAttrs, { onChange: e.handleChange }), createSlots({ _: 2 }, [
    renderList(Object.keys(e.$slots), (X) => ({
      name: X,
      fn: withCtx((Q) => [
        renderSlot(e.$slots, X, normalizeProps(guardReactiveProps(Q || {})))
      ])
    })),
    e.loading ? {
      name: "suffixIcon",
      fn: withCtx(() => [
        createVNode(G, { spin: "" })
      ]),
      key: "0"
    } : void 0
  ]), 1040, ["onChange"]);
}
const ApiTreeSelect = /* @__PURE__ */ _export_sfc(_sfc_main$h, [["render", _sfc_render$c]]), _sfc_main$g = defineComponent({
  name: "ApiCascader",
  components: {
    LoadingOutlined
  },
  props: {
    value: {
      type: Array
    },
    api: {
      type: Function,
      default: null
    },
    numberToString: propTypes.bool,
    resultField: propTypes.string.def(""),
    labelField: propTypes.string.def("label"),
    valueField: propTypes.string.def("value"),
    childrenField: propTypes.string.def("children"),
    asyncFetchParamKey: propTypes.string.def("parentCode"),
    immediate: propTypes.bool.def(!0),
    // init fetch params
    initFetchParams: {
      type: Object,
      default: () => ({})
    },
    // 是否有下级，默认是
    isLeaf: {
      type: Function,
      default: null
    },
    displayRenderArray: {
      type: Array
    }
  },
  emits: ["change", "defaultChange"],
  setup(e, { emit: k }) {
    const W = ref([]), H = ref([]), U = ref(!1), K = ref([]), G = ref(!0), Z = useI18n(), [X] = useRuleFormItem(e, "value", "change");
    watch(
      W,
      (ee) => {
        const ne = Q(ee);
        H.value = ne;
      },
      { deep: !0 }
    );
    function Q(ee) {
      const { labelField: ne, valueField: se, numberToString: le, childrenField: ae, isLeaf: de } = e;
      return ee.reduce((ue, fe) => {
        if (fe) {
          const ge = fe[se], ce = {
            ...omit(fe, [ne, se]),
            label: fe[ne],
            value: le ? `${ge}` : ge,
            isLeaf: de && typeof de == "function" ? de(fe) : !1
          }, me = Reflect.get(fe, ae);
          me && Reflect.set(ce, ae, Q(me)), ue.push(ce);
        }
        return ue;
      }, []);
    }
    async function te() {
      const ee = e.api;
      if (!(!ee || !isFunction(ee))) {
        W.value = [], U.value = !0;
        try {
          const ne = await ee(e.initFetchParams);
          if (Array.isArray(ne)) {
            W.value = ne;
            return;
          }
          e.resultField && (W.value = get$1(ne, e.resultField) || []);
        } catch (ne) {
          console.warn(ne);
        } finally {
          U.value = !1;
        }
      }
    }
    async function re(ee) {
      const ne = ee[ee.length - 1];
      ne.loading = !0;
      const se = e.api;
      if (!(!se || !isFunction(se)))
        try {
          const le = await se({
            [e.asyncFetchParamKey]: Reflect.get(ne, "value")
          });
          if (Array.isArray(le)) {
            const ae = Q(le);
            ne.children = ae;
            return;
          }
          if (e.resultField) {
            const ae = Q(get$1(le, e.resultField) || []);
            ne.children = ae;
          }
        } catch (le) {
          console.error(le);
        } finally {
          ne.loading = !1;
        }
    }
    watchEffect(() => {
      e.immediate && te();
    }), watch(
      () => e.initFetchParams,
      () => {
        !unref(G) && te();
      },
      { deep: !0 }
    );
    function oe(ee, ne) {
      K.value = ee, k("defaultChange", ee, ne);
    }
    function ie({ labels: ee, selectedOptions: ne }) {
      return unref(K).length === ne.length ? ee.join(" / ") : e.displayRenderArray ? e.displayRenderArray.join(" / ") : "";
    }
    return {
      state: X,
      options: H,
      loading: U,
      t: Z,
      handleChange: oe,
      loadData: re,
      handleRenderDisplay: ie
    };
  }
});
function _sfc_render$b(e, k, W, H, U, K) {
  const G = resolveComponent("LoadingOutlined"), Z = resolveComponent("Cascader");
  return openBlock(), createBlock(Z, {
    value: e.state,
    "onUpdate:value": k[0] || (k[0] = (X) => e.state = X),
    options: e.options,
    "load-data": e.loadData,
    "change-on-select": "",
    onChange: e.handleChange,
    displayRender: e.handleRenderDisplay
  }, createSlots({ _: 2 }, [
    e.loading ? {
      name: "suffixIcon",
      fn: withCtx(() => [
        createVNode(G, { spin: "" })
      ]),
      key: "0"
    } : void 0,
    e.loading ? {
      name: "notFoundContent",
      fn: withCtx(() => [
        createElementVNode("span", null, [
          createVNode(G, {
            spin: "",
            class: "mr-1"
          }),
          createTextVNode(" " + toDisplayString(e.t("form.apiSelectNotFound")), 1)
        ])
      ]),
      key: "1"
    } : void 0
  ]), 1032, ["value", "options", "load-data", "onChange", "displayRender"]);
}
const ApiCascader = /* @__PURE__ */ _export_sfc(_sfc_main$g, [["render", _sfc_render$b]]), _sfc_main$f = /* @__PURE__ */ defineComponent({
  __name: "Text",
  props: {
    value: {
      type: [Array, Object, String, Number]
    },
    format: {
      type: Function
    }
  },
  setup(e) {
    return (k, W) => (openBlock(), createElementBlock("span", normalizeProps(guardReactiveProps(k.$attrs)), toDisplayString(e.format ? e.format(e.value) : e.value), 17));
  }
}), componentMap = /* @__PURE__ */ new Map();
componentMap.set("Input", Input);
componentMap.set("InputGroup", Input.Group);
componentMap.set("InputPassword", Input.Password);
componentMap.set("InputSearch", Input.Search);
componentMap.set("InputTextArea", Input.TextArea);
componentMap.set("InputNumber", InputNumber);
componentMap.set("AutoComplete", AutoComplete);
componentMap.set("Select", Select);
componentMap.set("ApiSelect", ApiSelect);
componentMap.set("ApiSearch", ApiSearch);
componentMap.set("ApiSelectHighlight", ApiSelectHighlight);
componentMap.set("ApiTree", ApiTree);
componentMap.set("TreeSelect", TreeSelect);
componentMap.set("ApiTreeSelect", ApiTreeSelect);
componentMap.set("ApiRadioGroup", ApiRadioGroup);
componentMap.set("ApiCheckboxGroup", ApiCheckboxGroup);
componentMap.set("Switch", Switch);
componentMap.set("RadioButtonGroup", RadioButtonGroup);
componentMap.set("RadioGroup", Radio.Group);
componentMap.set("Checkbox", Checkbox);
componentMap.set("CheckboxGroup", Checkbox.Group);
componentMap.set("ApiCascader", ApiCascader);
componentMap.set("Cascader", Cascader);
componentMap.set("Slider", Slider);
componentMap.set("Rate", Rate);
componentMap.set("DatePicker", DatePicker);
componentMap.set("MonthPicker", DatePicker.MonthPicker);
componentMap.set("RangePicker", DatePicker.RangePicker);
componentMap.set("WeekPicker", DatePicker.WeekPicker);
componentMap.set("TimePicker", TimePicker);
componentMap.set("Divider", Divider);
componentMap.set("Text", _sfc_main$f);
function add(e, k) {
  componentMap.set(e, k);
}
function del(e) {
  componentMap.delete(e);
}
function useComponentRegister(e, k) {
  add(e, k), tryOnUnmounted(() => {
    del(e);
  });
}
function useForm(e) {
  const k = ref(null), W = ref(!1);
  async function H() {
    const G = unref(k);
    if (!G)
      throw new Error(
        "The form instance has not been obtained, please make sure that the form has been rendered when performing the form operation!"
      );
    return await nextTick(), G;
  }
  function U(G) {
    onUnmounted(() => {
      k.value = null, W.value = null;
    }), !(unref(W) && G === unref(k)) && (k.value = G, W.value = !0, watch(
      () => e,
      () => {
        e && G.setProps(getDynamicProps(e));
      },
      {
        immediate: !0,
        deep: !0
      }
    ));
  }
  return [U, {
    scrollToField: async (G, Z) => {
      (await H()).scrollToField(G, Z);
    },
    setProps: async (G) => {
      (await H()).setProps(G);
    },
    updateSchema: async (G) => {
      (await H()).updateSchema(G);
    },
    resetSchema: async (G) => {
      (await H()).resetSchema(G);
    },
    clearValidate: async (G) => {
      (await H()).clearValidate(G);
    },
    resetFields: async () => {
      H().then(async (G) => {
        await G.resetFields();
      });
    },
    removeSchemaByFiled: async (G) => {
      var Z;
      (Z = unref(k)) == null || Z.removeSchemaByFiled(G);
    },
    // TODO promisify
    getFieldsValue: () => {
      var G;
      return (G = unref(k)) == null ? void 0 : G.getFieldsValue();
    },
    setFieldsValue: async (G) => {
      (await H()).setFieldsValue(G);
    },
    appendSchemaByField: async (G, Z, X) => {
      (await H()).appendSchemaByField(G, Z, X);
    },
    submit: async () => (await H()).submit(),
    validate: async (G) => (await H()).validate(G),
    validateFields: async (G) => (await H()).validateFields(G)
  }];
}
const prefixCls = "g";
function createBem(e, k, W) {
  let H = e;
  return k && (H += `__${k}`), W && (H += `--${W}`), H;
}
function useNamespace(e, k = !1) {
  const W = k ? `.${prefixCls}-${e}` : `${prefixCls}-${e}`;
  return {
    b: () => createBem(W),
    e: (Z) => Z ? createBem(W, Z) : "",
    m: (Z) => Z ? createBem(W, "", Z) : "",
    em: (Z, X) => Z && X ? createBem(W, Z, X) : ""
  };
}
const _sfc_main$e = defineComponent({
  name: `${prefix}SvgIcon`,
  props: {
    prefix: {
      type: String,
      default: "icon"
    },
    name: {
      type: String,
      required: !0
    },
    size: {
      type: [Number, String],
      default: 16
    },
    spin: {
      type: Boolean,
      default: !1
    }
  },
  setup(e) {
    const W = useNamespace("svg-icon").b(), H = computed(() => `#${e.prefix}-${e.name}`), U = computed(() => {
      const { size: K } = e;
      let G = `${K}`;
      return G = `${G.replace("px", "")}px`, {
        width: G,
        height: G
      };
    });
    return { symbolId: H, prefixCls: W, getStyle: U };
  }
}), svgIcon_vue_vue_type_style_index_0_lang = "", _hoisted_1$2 = ["xlink:href"];
function _sfc_render$a(e, k, W, H, U, K) {
  return openBlock(), createElementBlock("svg", {
    class: normalizeClass([e.prefixCls, e.$attrs.class, e.spin && "svg-icon-spin"]),
    style: normalizeStyle(e.getStyle),
    "aria-hidden": "true"
  }, [
    createElementVNode("use", { "xlink:href": e.symbolId }, null, 8, _hoisted_1$2)
  ], 6);
}
const SvgIcon = /* @__PURE__ */ _export_sfc(_sfc_main$e, [["render", _sfc_render$a]]), SVG_END_WITH_FLAG = "|svg", _sfc_main$d = defineComponent({
  name: `${prefix}Icon`,
  components: { SvgIcon },
  props: {
    // icon name
    icon: String,
    // icon color
    color: String,
    // icon size
    size: {
      type: [String, Number],
      default: 16
    },
    spin: {
      type: Boolean,
      default: !1
    },
    prefix: {
      type: String,
      default: ""
    }
  },
  setup(e) {
    const k = ref(null), W = computed(() => {
      var Z;
      return (Z = e.icon) == null ? void 0 : Z.endsWith(SVG_END_WITH_FLAG);
    }), H = computed(
      () => e.icon.replace(SVG_END_WITH_FLAG, "")
    ), U = computed(
      () => `${e.prefix ? e.prefix + ":" : ""}${e.icon}`
    ), K = async () => {
      if (unref(W))
        return;
      const Z = unref(k);
      if (!Z)
        return;
      await nextTick();
      const X = unref(U);
      if (!X)
        return;
      const Q = Iconify.renderSVG(X, {});
      if (Q)
        Z.textContent = "", Z.appendChild(Q);
      else {
        const te = document.createElement("span");
        te.className = "iconify", te.dataset.icon = X, Z.textContent = "", Z.appendChild(te);
      }
    }, G = computed(() => {
      const { size: Z, color: X } = e;
      let Q = Z;
      return isString(Z) && (Q = parseInt(Z, 10)), {
        fontSize: `${Q}px`,
        color: X,
        display: "inline-flex"
      };
    });
    return watch(() => e.icon, K, { flush: "post" }), onMounted(K), { elRef: k, getWrapStyle: G, isSvgIcon: W, getSvgIcon: H };
  }
}), icon_vue_vue_type_style_index_0_lang = "";
function _sfc_render$9(e, k, W, H, U, K) {
  const G = resolveComponent("SvgIcon");
  return e.isSvgIcon ? (openBlock(), createBlock(G, {
    key: 0,
    size: e.size,
    name: e.getSvgIcon,
    class: normalizeClass([e.$attrs.class, "anticon"]),
    spin: e.spin
  }, null, 8, ["size", "name", "class", "spin"])) : (openBlock(), createElementBlock("span", {
    key: 1,
    ref: "elRef",
    class: normalizeClass([e.$attrs.class, "app-iconify anticon", e.spin && "app-iconify-spin"]),
    style: normalizeStyle(e.getWrapStyle)
  }, null, 6));
}
const Icon = /* @__PURE__ */ _export_sfc(_sfc_main$d, [["render", _sfc_render$9]]);
Icon.install = function(e, k) {
  e.component(k || Icon.name, Icon);
};
const _sfc_main$c = /* @__PURE__ */ defineComponent({
  __name: "BasicArrow",
  props: {
    /**
     * Arrow expand state
     */
    expand: { type: Boolean },
    /**
     * Arrow up by default
     */
    up: { type: Boolean },
    /**
     * Arrow down by default
     */
    down: { type: Boolean },
    /**
     * Cancel padding/margin for inline
     */
    inset: { type: Boolean }
  },
  setup(e) {
    const k = e, H = useNamespace("basic-arrow").b(), U = computed(() => {
      const { expand: K, up: G, down: Z, inset: X } = k;
      return [
        H,
        {
          [`${H}--active`]: K,
          up: G,
          inset: X,
          down: Z
        }
      ];
    });
    return (K, G) => (openBlock(), createElementBlock("span", {
      class: normalizeClass(U.value)
    }, [
      createVNode(unref(Icon), {
        icon: "ion:chevron-forward",
        style: normalizeStyle(K.$attrs.iconStyle)
      }, null, 8, ["style"])
    ], 2));
  }
}), BasicArrow_vue_vue_type_style_index_0_lang = "", props$1 = {
  /**
   * Help text max-width
   * @default: 600px
   */
  maxWidth: {
    type: String,
    default: "600px"
  },
  /**
   * Whether to display the serial number
   * @default: false
   */
  showIndex: {
    type: Boolean
  },
  /**
   * Help text font color
   * @default: #ffffff
   */
  color: {
    type: String,
    default: "#ffffff"
  },
  /**
   * Help text font size
   * @default: 14px
   */
  fontSize: {
    type: String,
    default: "14px"
  },
  /**
   * Help text list
   */
  placement: {
    type: String,
    default: "right"
  },
  /**
   * Help text list
   */
  text: {
    type: [Array, String]
  }
}, _sfc_main$b = /* @__PURE__ */ defineComponent({
  name: "BasicHelp",
  components: {
    Tooltip
  },
  props: props$1,
  setup(e, {
    slots: k
  }) {
    const H = useNamespace("basic-help").b(), U = computed(() => ({
      color: e.color,
      fontSize: e.fontSize
    })), K = computed(() => ({
      maxWidth: e.maxWidth
    }));
    function G() {
      const X = e.text;
      return isString(X) ? createVNode("p", null, [X]) : isArray(X) ? X.map((Q, te) => createVNode("p", {
        key: Q
      }, [createVNode(Fragment, null, [e.showIndex ? `${te + 1}. ` : "", Q])])) : null;
    }
    function Z(X) {
      return (X == null ? void 0 : X.parentNode) ?? document.body;
    }
    return () => createVNode(Tooltip, {
      overlayClassName: `${H}__wrap`,
      title: createVNode("div", {
        style: unref(U)
      }, [G()]),
      autoAdjustOverflow: !0,
      overlayStyle: unref(K),
      placement: e.placement,
      getPopupContainer: () => Z()
    }, {
      default: () => [createVNode("span", {
        class: H
      }, [getSlot(k) || createVNode(InfoCircleOutlined, null, null)])]
    });
  }
}), BasicHelp_vue_vue_type_style_index_0_lang = "", _sfc_main$a = /* @__PURE__ */ defineComponent({
  __name: "BasicTitle",
  props: {
    /**
     * Help text list or string
     * @default: ''
     */
    helpMessage: {
      type: [String, Array],
      default: ""
    },
    /**
     * Whether the color block on the left side of the title
     * @default: false
     */
    span: { type: Boolean },
    /**
     * Whether to default the text, that is, not bold
     * @default: false
     */
    normal: { type: Boolean }
  },
  setup(e) {
    const k = useNamespace("basic-title"), W = e, H = k.b(), U = useSlots(), K = computed(() => [
      H,
      { [`${H}-show-span`]: W.span && U.default },
      { [`${H}-normal`]: W.normal }
    ]);
    return (G, Z) => (openBlock(), createElementBlock("span", {
      class: normalizeClass(K.value)
    }, [
      renderSlot(G.$slots, "default"),
      e.helpMessage ? (openBlock(), createBlock(_sfc_main$b, {
        key: 0,
        class: normalizeClass(`${unref(H)}-help`),
        text: e.helpMessage
      }, null, 8, ["class", "text"])) : createCommentVNode("", !0)
    ], 2));
  }
}), BasicTitle_vue_vue_type_style_index_0_lang = "", t$1 = useI18n();
function createPlaceholderMessage(e) {
  return e.includes("Input") || e.includes("Complete") ? t$1("common.inputText") : e.includes("Picker") || e.includes("Select") || e.includes("Cascader") || e.includes("Checkbox") || e.includes("Radio") || e.includes("Switch") ? t$1("common.chooseText") : "";
}
const DATE_TYPE = ["DatePicker", "MonthPicker", "WeekPicker", "TimePicker"];
function genType() {
  return [...DATE_TYPE, "RangePicker"];
}
function setComponentRuleType(e, k, W) {
  ["DatePicker", "MonthPicker", "WeekPicker", "TimePicker"].includes(
    k
  ) ? e.type = W ? "string" : "object" : ["RangePicker", "Upload", "CheckboxGroup", "TimePicker"].includes(k) ? e.type = "array" : ["InputNumber"].includes(k) && (e.type = "number");
}
function handleInputNumberValue(e, k) {
  return e && ["Input", "InputPassword", "InputSearch", "InputTextArea"].includes(
    e
  ) && k && isNumber(k) ? `${k}` : k;
}
const dateItemType = genType(), defaultValueComponents = [
  "Input",
  "InputPassword",
  "InputSearch",
  "InputTextArea"
];
function useItemLabelWidth(e, k) {
  return computed(() => {
    const W = unref(e), { labelCol: H = {}, wrapperCol: U = {} } = W.itemProps || {}, { labelWidth: K, disabledLabelWidth: G } = W, {
      labelWidth: Z,
      labelCol: X,
      wrapperCol: Q,
      layout: te
    } = unref(k);
    if (!Z && !K && !X || G)
      return H.style = {
        textAlign: "left"
      }, { labelCol: H, wrapperCol: U };
    let re = K || Z;
    const oe = { ...X, ...H }, ie = { ...Q, ...U };
    return re && (re = isNumber(re) ? `${re}px` : re), {
      labelCol: { style: { width: re }, ...oe },
      wrapperCol: {
        style: {
          width: te === "vertical" ? "100%" : `calc(100% - ${re})`
        },
        ...ie
      }
    };
  });
}
function _isSlot$1(e) {
  return typeof e == "function" || Object.prototype.toString.call(e) === "[object Object]" && !isVNode(e);
}
const _sfc_main$9 = /* @__PURE__ */ defineComponent({
  name: "BasicFormItem",
  inheritAttrs: !1,
  props: {
    schema: {
      type: Object,
      default: () => ({})
    },
    formProps: {
      type: Object,
      default: () => ({})
    },
    allDefaultValues: {
      type: Object,
      default: () => ({})
    },
    formModel: {
      type: Object,
      default: () => ({})
    },
    setFormModel: {
      type: Function,
      default: null
    },
    tableAction: {
      type: Object
    },
    formActionType: {
      type: Object
    }
  },
  setup(e, {
    slots: k
  }) {
    const W = useI18n(), {
      schema: H,
      formProps: U
    } = toRefs(e), K = useItemLabelWidth(H, U), G = computed(() => {
      const {
        allDefaultValues: ee,
        formModel: ne,
        schema: se
      } = e, {
        mergeDynamicData: le
      } = e.formProps;
      return {
        field: se.field,
        model: ne,
        values: {
          ...le,
          ...ee,
          ...ne
        },
        schema: se
      };
    }), Z = computed(() => {
      const {
        schema: ee,
        tableAction: ne,
        formModel: se,
        formActionType: le
      } = e;
      let {
        componentProps: ae = {}
      } = ee;
      return isFunction(ae) && (ae = ae({
        schema: ee,
        tableAction: ne,
        formModel: se,
        formActionType: le
      }) ?? {}), ee.component === "Divider" && (ae = Object.assign({
        type: "horizontal"
      }, ae, {
        orientation: "left",
        plain: !0
      })), ae;
    }), X = computed(() => {
      const {
        disabled: ee
      } = e.formProps, {
        dynamicDisabled: ne
      } = e.schema, {
        disabled: se = !1
      } = unref(Z);
      let le = !!ee || se;
      return isBoolean(ne) && (le = ne), isFunction(ne) && (le = ne(unref(G))), le;
    });
    function Q() {
      const {
        show: ee,
        ifShow: ne
      } = e.schema, {
        showAdvancedButton: se
      } = e.formProps, le = se && isBoolean(e.schema.isAdvanced) ? e.schema.isAdvanced : !0;
      let ae = !0, de = !0;
      return isBoolean(ee) && (ae = ee), isBoolean(ne) && (de = ne), isFunction(ee) && (ae = ee(unref(G))), isFunction(ne) && (de = ne(unref(G))), ae = ae && le, {
        isShow: ae,
        isIfShow: de
      };
    }
    function te() {
      var Te;
      const {
        rules: ee = [],
        component: ne,
        rulesMessageJoinLabel: se,
        label: le,
        dynamicRules: ae,
        required: de
      } = e.schema;
      if (isFunction(ae))
        return ae(unref(G));
      let ue = cloneDeep(ee);
      const {
        rulesMessageJoinLabel: fe
      } = e.formProps, ge = Reflect.has(e.schema, "rulesMessageJoinLabel") ? se : fe, ce = createPlaceholderMessage(ne) + `${ge ? le : ""}`;
      function me(ye, he) {
        const _e = ye.message || ce;
        return he === void 0 || isNull(he) || Array.isArray(he) && he.length === 0 || typeof he == "string" && he.trim() === "" || typeof he == "object" && Reflect.has(he, "checked") && Reflect.has(he, "halfChecked") && Array.isArray(he.checked) && Array.isArray(he.halfChecked) && he.checked.length === 0 && he.halfChecked.length === 0 ? Promise.reject(_e) : Promise.resolve();
      }
      const ve = isFunction(de) ? de(unref(G)) : de;
      ve && (!ue || ue.length === 0 ? ue = [{
        required: ve,
        validator: me
      }] : ue.findIndex((he) => Reflect.has(he, "required")) === -1 && ue.push({
        required: ve,
        validator: me
      }));
      const we = ue.findIndex((ye) => Reflect.has(ye, "required") && !Reflect.has(ye, "validator"));
      if (we !== -1) {
        const ye = ue[we], {
          isShow: he
        } = Q();
        if (he || (ye.required = !1), ne) {
          Reflect.has(ye, "type") || (ye.type = ne === "InputNumber" ? "number" : "string"), ye.message = ye.message || ce, (ne.includes("Input") || ne.includes("Textarea")) && (ye.whitespace = !0);
          const _e = (Te = unref(Z)) == null ? void 0 : Te.valueFormat;
          setComponentRuleType(ye, ne, _e);
        }
      }
      const Ce = ue.findIndex((ye) => ye.max);
      return Ce !== -1 && !ue[Ce].validator && (ue[Ce].message = ue[Ce].message || W("form.maxTip", [ue[Ce].max])), ue;
    }
    function re() {
      var he;
      const {
        renderComponentContent: ee,
        component: ne,
        field: se,
        changeEvent: le = "change",
        valueField: ae
      } = e.schema, de = ne && ["Switch", "Checkbox"].includes(ne), ue = `on${upperFirst(le)}`, fe = {
        [ue]: (..._e) => {
          const [$e] = _e;
          ve[ue] && ve[ue](..._e);
          const Fe = $e ? $e.target : null, ke = Fe ? de ? Fe.checked : Fe.value : $e;
          e.setFormModel(se, ke);
        }
      }, ge = componentMap.get(ne), {
        autoSetPlaceHolder: ce,
        size: me
      } = e.formProps, ve = {
        allowClear: !0,
        getPopupContainer: (_e) => _e.parentNode,
        size: me,
        ...unref(Z),
        disabled: unref(X)
      };
      !ve.disabled && ce && ne !== "RangePicker" && ne && (ve.placeholder = ((he = unref(Z)) == null ? void 0 : he.placeholder) || createPlaceholderMessage(ne)), ve.codeField = se, ve.formValues = unref(G);
      const Ce = {
        [ae || (de ? "checked" : "value")]: e.formModel[se]
      }, Te = {
        ...ve,
        ...fe,
        ...Ce
      };
      if (!ee)
        return createVNode(ge, Te, null);
      const ye = isFunction(ee) ? {
        ...ee(unref(G))
      } : {
        default: () => ee
      };
      return createVNode(ge, Te, _isSlot$1(ye) ? ye : {
        default: () => [ye]
      });
    }
    function oe() {
      const {
        label: ee,
        helpMessage: ne,
        helpComponentProps: se,
        subLabel: le
      } = e.schema, {
        formModel: ae,
        formActionType: de
      } = e, ue = le ? createVNode("span", {
        class: "label-item"
      }, [ee, " ", createVNode("span", {
        class: "text-secondary"
      }, [isFunction(le) ? le({
        formModel: ae,
        formActionType: de
      }) : le])]) : ee, fe = isFunction(ne) ? ne(unref(G)) : ne;
      return !fe || Array.isArray(fe) && fe.length === 0 ? ue : createVNode("span", null, [ue, createVNode(_sfc_main$b, mergeProps({
        placement: "top",
        class: "mx-1",
        text: fe
      }, se), null)]);
    }
    function ie() {
      const {
        itemProps: ee,
        slot: ne,
        render: se,
        field: le,
        suffix: ae,
        component: de
      } = e.schema, {
        labelCol: ue,
        wrapperCol: fe
      } = unref(K), {
        colon: ge
      } = e.formProps;
      if (de === "Divider") {
        let ce;
        return createVNode(Col, {
          span: 24
        }, {
          default: () => [createVNode(Divider, unref(Z), _isSlot$1(ce = oe()) ? ce : {
            default: () => [ce]
          })]
        });
      } else {
        const ce = () => ne ? getSlot(k, ne, unref(G)) : se ? se(unref(G)) : re(), me = !!ae, ve = isFunction(ae) ? ae(unref(G)) : ae;
        return createVNode(Form.Item, mergeProps({
          name: le,
          colon: ge,
          class: {
            "suffix-item": me
          }
        }, ee, {
          label: oe(),
          rules: te(),
          labelCol: ue,
          wrapperCol: fe
        }), {
          default: () => [createVNode("div", {
            style: "display:flex",
            class: "form-item-wrapper"
          }, [createVNode("div", {
            style: "flex:1;",
            class: "form-item-container"
          }, [ce()]), me && createVNode("span", {
            class: "suffix"
          }, [ve])])]
        });
      }
    }
    return () => {
      let ee;
      const {
        colProps: ne = {},
        colSlot: se,
        renderColContent: le,
        component: ae
      } = e.schema;
      if (!componentMap.has(ae))
        return null;
      const {
        baseColProps: de = {}
      } = e.formProps, ue = {
        ...de,
        ...ne
      }, {
        isIfShow: fe,
        isShow: ge
      } = Q(), ce = unref(G);
      return fe && withDirectives(createVNode(Col, ue, _isSlot$1(ee = (() => se ? getSlot(k, se, ce) : le ? le(ce) : ie())()) ? ee : {
        default: () => [ee]
      }), [[vShow, ge]]);
    };
  }
});
function createContext(e, k = Symbol(), W = {}) {
  const { readonly: H = !0, createProvider: U = !1, native: K = !1 } = W, G = reactive(e), Z = H ? readonly(G) : G;
  return !U && provide(k, K ? e : Z), {
    state: G
  };
}
function useContext(e = Symbol(), k) {
  return inject(e, k || {});
}
const key$1 = Symbol();
function createFormContext(e) {
  return createContext(e, key$1);
}
function useFormContext() {
  return useContext(key$1);
}
const _sfc_main$8 = defineComponent({
  name: "BasicFormAction",
  components: {
    FormItem: Form.Item,
    Button,
    BasicArrow: _sfc_main$c,
    Col
  },
  props: {
    showActionButtonGroup: propTypes.bool.def(!0),
    showResetButton: propTypes.bool.def(!0),
    showSubmitButton: propTypes.bool.def(!0),
    showAdvancedButton: propTypes.bool.def(!0),
    resetButtonOptions: {
      type: Object,
      default: () => ({})
    },
    submitButtonOptions: {
      type: Object,
      default: () => ({})
    },
    actionColOptions: {
      type: Object,
      default: () => ({})
    },
    actionSpan: propTypes.number.def(6),
    isAdvanced: propTypes.bool,
    hideAdvanceBtn: propTypes.bool
  },
  emits: ["toggle-advanced"],
  setup(e, { emit: k }) {
    const W = useI18n(), H = computed(() => {
      const { showAdvancedButton: Z, actionSpan: X, actionColOptions: Q } = e, te = 24 - X, re = Z ? { span: te < 6 ? 24 : te } : {};
      return {
        style: { textAlign: "right" },
        span: Z ? 6 : 4,
        ...re,
        ...Q
      };
    }), U = computed(() => Object.assign(
      {
        text: W("common.resetText")
      },
      e.resetButtonOptions
    )), K = computed(() => Object.assign(
      {
        text: W("common.queryText")
      },
      e.submitButtonOptions
    ));
    function G() {
      k("toggle-advanced");
    }
    return {
      t: W,
      actionColOpt: H,
      getResetBtnOptions: U,
      getSubmitBtnOptions: K,
      toggleAdvanced: G,
      ...useFormContext()
    };
  }
}), FormAction_vue_vue_type_style_index_0_scoped_e4b3ea8a_lang = "";
function _sfc_render$8(e, k, W, H, U, K) {
  const G = resolveComponent("Button"), Z = resolveComponent("BasicArrow"), X = resolveComponent("FormItem"), Q = resolveComponent("Col");
  return e.showActionButtonGroup ? (openBlock(), createBlock(Q, normalizeProps(mergeProps({ key: 0 }, e.actionColOpt)), {
    default: withCtx(() => [
      createElementVNode("div", {
        style: normalizeStyle([{ width: "100%" }, { textAlign: e.actionColOpt.style.textAlign }])
      }, [
        createVNode(X, null, {
          default: withCtx(() => [
            renderSlot(e.$slots, "resetBefore", {}, void 0, !0),
            e.showResetButton ? (openBlock(), createBlock(G, mergeProps({
              key: 0,
              type: "default",
              class: "mr-2"
            }, e.getResetBtnOptions, { onClick: e.resetAction }), {
              default: withCtx(() => [
                createTextVNode(toDisplayString(e.getResetBtnOptions.text), 1)
              ]),
              _: 1
            }, 16, ["onClick"])) : createCommentVNode("", !0),
            renderSlot(e.$slots, "submitBefore", {}, void 0, !0),
            e.showSubmitButton ? (openBlock(), createBlock(G, mergeProps({
              key: 1,
              type: "primary",
              class: "mr-2 submit-btn"
            }, e.getSubmitBtnOptions, { onClick: e.submitAction }), {
              default: withCtx(() => [
                createTextVNode(toDisplayString(e.getSubmitBtnOptions.text), 1)
              ]),
              _: 1
            }, 16, ["onClick"])) : createCommentVNode("", !0),
            renderSlot(e.$slots, "advanceBefore", {}, void 0, !0),
            e.showAdvancedButton && !e.hideAdvanceBtn ? (openBlock(), createBlock(G, {
              key: 2,
              type: "link",
              size: "small",
              onClick: e.toggleAdvanced
            }, {
              default: withCtx(() => [
                createTextVNode(toDisplayString(e.isAdvanced ? e.t("form.putAway") : e.t("form.unfold")) + " ", 1),
                createVNode(Z, {
                  class: "ml-1",
                  expand: !e.isAdvanced,
                  up: ""
                }, null, 8, ["expand"])
              ]),
              _: 1
            }, 8, ["onClick"])) : createCommentVNode("", !0),
            renderSlot(e.$slots, "advanceAfter", {}, void 0, !0)
          ]),
          _: 3
        })
      ], 4)
    ]),
    _: 3
  }, 16)) : createCommentVNode("", !0);
}
const FormAction = /* @__PURE__ */ _export_sfc(_sfc_main$8, [["render", _sfc_render$8], ["__scopeId", "data-v-e4b3ea8a"]]);
function tryDeconstructArray(e, k, W) {
  const H = /^\[(.+)\]$/;
  if (H.test(e)) {
    const U = e.match(H);
    if (U && U[1]) {
      const K = U[1].split(",");
      return k = Array.isArray(k) ? k : [k], K.forEach((G, Z) => {
        set(W, G.trim(), k[Z]);
      }), !0;
    }
  }
}
function tryDeconstructObject(e, k, W) {
  const H = /^\{(.+)\}$/;
  if (H.test(e)) {
    const U = e.match(H);
    if (U && U[1]) {
      const K = U[1].split(",");
      return k = isObject(k) ? k : {}, K.forEach((G) => {
        set(W, G.trim(), k[G.trim()]);
      }), !0;
    }
  }
}
function useFormValues({
  defaultValueRef: e,
  getSchema: k,
  formModel: W,
  getProps: H
}) {
  function U(Z) {
    var Q, te;
    if (!isObject(Z))
      return {};
    const X = {};
    for (const re of Object.entries(Z)) {
      let [, oe] = re;
      const [ie] = re;
      if (!ie || isArray(oe) && oe.length === 0 || isFunction(oe))
        continue;
      const ee = unref(H).transformDateFunc;
      isObject(oe) && (oe = ee == null ? void 0 : ee(oe)), isArray(oe) && ((Q = oe[0]) != null && Q.format) && ((te = oe[1]) != null && te.format) && (oe = oe.map((ne) => ee == null ? void 0 : ee(ne))), isString(oe) && (oe = oe.trim()), !tryDeconstructArray(ie, oe, X) && !tryDeconstructObject(ie, oe, X) && set(X, ie, oe);
    }
    return K(X);
  }
  function K(Z) {
    const X = unref(H).fieldMapToTime;
    if (!X || !Array.isArray(X))
      return Z;
    for (const [
      Q,
      [te, re],
      oe = "YYYY-MM-DD"
    ] of X) {
      if (!Q || !te || !re || !Z[Q])
        continue;
      const [ie, ee] = Z[Q];
      Z[te] = dateUtil(ie).format(oe), Z[re] = dateUtil(ee).format(oe), Reflect.deleteProperty(Z, Q);
    }
    return Z;
  }
  function G() {
    const Z = unref(k), X = {};
    Z.forEach((Q) => {
      const { defaultValue: te } = Q;
      isNullOrUnDef(te) || (X[Q.field] = te, W[Q.field] === void 0 && (W[Q.field] = te));
    }), e.value = X;
  }
  return { handleFormValues: U, initDefault: G };
}
var screenEnum = /* @__PURE__ */ ((e) => (e[e.XS = 480] = "XS", e[e.SM = 576] = "SM", e[e.MD = 768] = "MD", e[e.LG = 992] = "LG", e[e.XL = 1200] = "XL", e[e.XXL = 1600] = "XXL", e))(screenEnum || {});
const screenMap = /* @__PURE__ */ new Map();
screenMap.set(
  "XS",
  480
  /* XS */
);
screenMap.set(
  "SM",
  576
  /* SM */
);
screenMap.set(
  "MD",
  768
  /* MD */
);
screenMap.set(
  "LG",
  992
  /* LG */
);
screenMap.set(
  "XL",
  1200
  /* XL */
);
screenMap.set(
  "XXL",
  1600
  /* XXL */
);
let globalScreenRef, globalWidthRef, globalRealWidthRef;
function useBreakpoint() {
  return {
    screenRef: computed(() => unref(globalScreenRef)),
    widthRef: globalWidthRef,
    screenEnum,
    realWidthRef: globalRealWidthRef
  };
}
const BASIC_COL_LEN = 24;
function useAdvanced({
  advanceState: e,
  emit: k,
  getProps: W,
  getSchema: H,
  formModel: U,
  defaultValueRef: K
}) {
  const { realWidthRef: G, screenEnum: Z, screenRef: X } = useBreakpoint(), Q = computed(() => {
    if (!e.isAdvanced)
      return 0;
    const ee = unref(W).emptySpan || 0;
    if (isNumber(ee))
      return ee;
    if (isObject(ee)) {
      const { span: ne = 0 } = ee, se = unref(X);
      return ee[se.toLowerCase()] || ne || 0;
    }
    return 0;
  }), te = useDebounceFn(oe, 30);
  watch(
    [
      () => unref(H),
      () => e.isAdvanced,
      () => unref(G)
    ],
    () => {
      const { showAdvancedButton: ee } = unref(W);
      ee && te();
    },
    { immediate: !0 }
  );
  function re(ee, ne = 0, se = !1) {
    const le = unref(G), ae = parseInt(ee.md) || parseInt(ee.xs) || parseInt(ee.sm) || ee.span || BASIC_COL_LEN, de = parseInt(ee.lg) || ae, ue = parseInt(ee.xl) || de, fe = parseInt(ee.xxl) || ue;
    return le <= Z.LG ? ne += ae : le < Z.XL ? ne += de : le < Z.XXL ? ne += ue : ne += fe, se ? (e.hideAdvanceBtn = !1, ne <= BASIC_COL_LEN * 2 ? (e.hideAdvanceBtn = !0, e.isAdvanced = !0) : ne > BASIC_COL_LEN * 2 && ne <= BASIC_COL_LEN * (unref(W).autoAdvancedLine || 3) ? e.hideAdvanceBtn = !1 : e.isLoad || (e.isLoad = !0, e.isAdvanced = !e.isAdvanced), { isAdvanced: e.isAdvanced, itemColSum: ne }) : ne > BASIC_COL_LEN * (unref(W).alwaysShowLines || 1) ? { isAdvanced: e.isAdvanced, itemColSum: ne } : { isAdvanced: !0, itemColSum: ne };
  }
  function oe() {
    let ee = 0, ne = 0;
    const { baseColProps: se = {} } = unref(W);
    for (const le of unref(H)) {
      const { show: ae, colProps: de } = le;
      let ue = !0;
      if (isBoolean(ae) && (ue = ae), isFunction(ae) && (ue = ae({
        schema: le,
        model: U,
        field: le.field,
        values: {
          ...unref(K),
          ...U
        }
      })), ue && (de || se)) {
        const { itemColSum: fe, isAdvanced: ge } = re(
          { ...se, ...de },
          ee
        );
        ee = fe || 0, ge && (ne = ee), le.isAdvanced = ge;
      }
    }
    e.actionSpan = ne % BASIC_COL_LEN + unref(Q), re(
      unref(W).actionColOptions || { span: BASIC_COL_LEN },
      ee,
      !0
    ), k("advanced-change");
  }
  function ie() {
    e.isAdvanced = !e.isAdvanced;
  }
  return { handleToggleAdvanced: ie };
}
function useFormEvents({
  emit,
  getProps,
  formModel,
  getSchema,
  defaultValueRef,
  formElRef,
  schemaRef,
  handleFormValues
}) {
  async function resetFields() {
    const { resetFunc: e, submitOnReset: k } = unref(getProps);
    e && isFunction(e) && await e(), unref(formElRef) && (Object.keys(formModel).forEach((H) => {
      const U = unref(getSchema).find((G) => G.field === H), K = (U == null ? void 0 : U.component) && defaultValueComponents.includes(U.component);
      formModel[H] = K ? defaultValueRef.value[H] || "" : defaultValueRef.value[H];
    }), nextTick(() => clearValidate()), emit("reset", toRaw(formModel)), k && handleSubmit());
  }
  async function setFieldsValue(values) {
    const fields = unref(getSchema).map((e) => e.field).filter(Boolean), delimiter = ".", nestKeyArray = fields.filter((e) => e.indexOf(delimiter) >= 0), validKeys = [];
    Object.keys(values).forEach((key) => {
      const schema = unref(getSchema).find((e) => e.field === key);
      let value = values[key];
      const hasKey = Reflect.has(values, key);
      if (value = handleInputNumberValue(schema == null ? void 0 : schema.component, value), hasKey && fields.includes(key)) {
        if (itemIsDateType(key))
          if (Array.isArray(value)) {
            const e = [];
            for (const k of value)
              e.push(k ? dateUtil(k) : null);
            formModel[key] = e;
          } else {
            const { componentProps: e } = schema || {};
            let k = e;
            typeof e == "function" && (k = k({ formModel })), formModel[key] = value ? k != null && k.valueFormat ? value : dateUtil(value) : null;
          }
        else
          formModel[key] = value;
        validKeys.push(key);
      } else
        nestKeyArray.forEach((nestKey) => {
          try {
            const value = eval("values" + delimiter + nestKey);
            isDef(value) && (formModel[nestKey] = value, validKeys.push(nestKey));
          } catch (e) {
            isDef(defaultValueRef.value[nestKey]) && (formModel[nestKey] = defaultValueRef.value[nestKey]);
          }
        });
    }), validateFields(validKeys).catch((e) => {
      console.log(e);
    });
  }
  async function removeSchemaByFiled(e) {
    const k = cloneDeep(unref(getSchema));
    if (!e)
      return;
    let W = isString(e) ? [e] : e;
    isString(e) && (W = [e]);
    for (const H of W)
      _removeSchemaByFiled(H, k);
    schemaRef.value = k;
  }
  function _removeSchemaByFiled(e, k) {
    if (isString(e)) {
      const W = k.findIndex((H) => H.field === e);
      W !== -1 && (delete formModel[e], k.splice(W, 1));
    }
  }
  async function appendSchemaByField(e, k, W = !1) {
    const H = cloneDeep(unref(getSchema)), U = H.findIndex(
      (K) => K.field === k
    );
    if (!k || U === -1 || W) {
      W ? H.unshift(e) : H.push(e), schemaRef.value = H, _setDefaultValue(e);
      return;
    }
    U !== -1 && H.splice(U + 1, 0, e), _setDefaultValue(e), schemaRef.value = H;
  }
  async function resetSchema(e) {
    let k = [];
    if (isObject(e) && k.push(e), isArray(e) && (k = [...e]), !k.every(
      (H) => H.component === "Divider" || Reflect.has(H, "field") && H.field
    )) {
      error(
        "All children of the form Schema array that need to be updated must contain the `field` field"
      );
      return;
    }
    schemaRef.value = k;
  }
  async function updateSchema(e) {
    let k = [];
    if (isObject(e) && k.push(e), isArray(e) && (k = [...e]), !k.every(
      (U) => U.component === "Divider" || Reflect.has(U, "field") && U.field
    )) {
      error(
        "All children of the form Schema array that need to be updated must contain the `field` field"
      );
      return;
    }
    const H = [];
    k.forEach((U) => {
      unref(getSchema).forEach((K) => {
        if (K.field === U.field) {
          const G = deepMergeObject(K, U);
          H.push(G);
        } else
          H.push(K);
      });
    }), _setDefaultValue(H), schemaRef.value = uniqBy(H, "field");
  }
  function _setDefaultValue(e) {
    let k = [];
    isObject(e) && k.push(e), isArray(e) && (k = [...e]);
    const W = {};
    k.forEach((H) => {
      H.component !== "Divider" && Reflect.has(H, "field") && H.field && !isNullOrUnDef(H.defaultValue) && (W[H.field] = H.defaultValue);
    }), setFieldsValue(W);
  }
  function getFieldsValue() {
    return unref(formElRef) ? handleFormValues(toRaw(unref(formModel))) : {};
  }
  function itemIsDateType(e) {
    return unref(getSchema).some((k) => k.field === e ? dateItemType.includes(k.component) : !1);
  }
  async function validateFields(e) {
    var k;
    return (k = unref(formElRef)) == null ? void 0 : k.validateFields(e);
  }
  async function validate(e) {
    var k;
    return await ((k = unref(formElRef)) == null ? void 0 : k.validate(e));
  }
  async function clearValidate(e) {
    var k;
    await ((k = unref(formElRef)) == null ? void 0 : k.clearValidate(e));
  }
  async function scrollToField(e, k) {
    var W;
    await ((W = unref(formElRef)) == null ? void 0 : W.scrollToField(e, k));
  }
  async function handleSubmit(e) {
    e && e.preventDefault();
    const { submitFunc: k } = unref(getProps);
    if (k && isFunction(k)) {
      await k();
      return;
    }
    if (unref(formElRef))
      try {
        const H = await validate(), U = handleFormValues(H);
        emit("submit", U);
      } catch (H) {
        throw new Error(H);
      }
  }
  return {
    handleSubmit,
    clearValidate,
    validate,
    validateFields,
    getFieldsValue,
    updateSchema,
    resetSchema,
    appendSchemaByField,
    removeSchemaByFiled,
    resetFields,
    setFieldsValue,
    scrollToField
  };
}
async function useAutoFocus({
  getSchema: e,
  getProps: k,
  formElRef: W,
  isInitedDefault: H
}) {
  watchEffect(async () => {
    if (unref(H) || !unref(k).autoFocusFirstItem)
      return;
    await nextTick();
    const U = unref(e), K = unref(W), G = K == null ? void 0 : K.$el;
    if (!K || !G || !U || U.length === 0 || !U[0].component.includes("Input"))
      return;
    const X = G.querySelector(
      ".ant-row:first-child input"
    );
    X && (X == null || X.focus());
  });
}
const t = useI18n(), modalProps = {
  visible: { type: Boolean },
  scrollTop: { type: Boolean, default: !0 },
  height: { type: Number },
  minHeight: { type: Number },
  // open drag
  draggable: { type: Boolean, default: !0 },
  centered: { type: Boolean },
  cancelText: { type: String, default: t("modal.cancelText") },
  okText: { type: String, default: t("modal.okText") },
  closeFunc: Function
}, basicProps$1 = Object.assign({}, modalProps, {
  defaultFullscreen: { type: Boolean },
  // Can it be full screen
  canFullscreen: { type: Boolean, default: !0 },
  // After enabling the wrapper, the bottom can be increased in height
  wrapperFooterOffset: { type: Number, default: 0 },
  // Warm reminder message
  helpMessage: [String, Array],
  // Whether to setting wrapper
  useWrapper: { type: Boolean, default: !0 },
  loading: { type: Boolean },
  loadingTip: { type: String },
  /**
   * @description: Show close button
   */
  showCancelBtn: { type: Boolean, default: !0 },
  /**
   * @description: Show confirmation button
   */
  showOkBtn: { type: Boolean, default: !0 },
  wrapperProps: Object,
  afterClose: Function,
  bodyStyle: Object,
  closable: { type: Boolean, default: !0 },
  closeIcon: Object,
  confirmLoading: { type: Boolean },
  destroyOnClose: { type: Boolean, default: !0 },
  footer: Object,
  getContainer: Function,
  mask: { type: Boolean, default: !0 },
  maskClosable: { type: Boolean, default: !0 },
  keyboard: { type: Boolean, default: !0 },
  maskStyle: Object,
  okType: { type: String, default: "primary" },
  okButtonProps: Object,
  cancelButtonProps: Object,
  title: { type: String },
  visible: { type: Boolean },
  width: [String, Number],
  wrapClassName: { type: String },
  zIndex: { type: Number }
});
function useTimeoutRef(e) {
  const k = ref(!1);
  let W;
  function H() {
    k.value = !1, W && window.clearTimeout(W);
  }
  function U() {
    H(), W = setTimeout(() => {
      k.value = !0;
    }, e);
  }
  return U(), tryOnUnmounted(H), { readyRef: k, stop: H, start: U };
}
function useTimeoutFn(e, k, W = !1) {
  if (!isFunction(e))
    throw new Error("handle is not Function!");
  const { readyRef: H, stop: U, start: K } = useTimeoutRef(k);
  return W ? e() : watch(
    H,
    (G) => {
      G && e();
    },
    { immediate: !1 }
  ), { readyRef: H, stop: U, start: K };
}
function useModalDragMove(e) {
  const k = (U, K) => getComputedStyle(U)[K], W = (U) => {
    if (!U)
      return;
    U.setAttribute("data-drag", unref(e.draggable));
    const K = U.querySelector(".ant-modal-header"), G = U.querySelector(".ant-modal");
    !K || !G || !unref(e.draggable) || (K.style.cursor = "move", K.onmousedown = (Z) => {
      if (!Z)
        return;
      const X = Z.clientX, Q = Z.clientY, te = document.body.clientWidth, re = document.documentElement.clientHeight, oe = G.offsetWidth, ie = G.offsetHeight, ee = G.offsetLeft, ne = te - G.offsetLeft - oe, se = G.offsetTop, le = re - G.offsetTop - ie, ae = k(G, "left"), de = k(G, "top");
      let ue = +ae, fe = +de;
      ae.includes("%") ? (ue = +document.body.clientWidth * (+ae.replace(/%/g, "") / 100), fe = +document.body.clientHeight * (+de.replace(/%/g, "") / 100)) : (ue = +ae.replace(/px/g, ""), fe = +de.replace(/px/g, "")), document.onmousemove = function(ge) {
        let ce = ge.clientX - X, me = ge.clientY - Q;
        -ce > ee ? ce = -ee : ce > ne && (ce = ne), -me > se ? me = -se : me > le && (me = le), G.style.cssText += `;left:${ce + ue}px;top:${me + fe}px;`;
      }, document.onmouseup = () => {
        document.onmousemove = null, document.onmouseup = null;
      };
    });
  }, H = () => {
    const U = document.querySelectorAll(".ant-modal-wrap");
    for (const K of Array.from(U)) {
      if (!K)
        continue;
      const G = k(K, "display"), Z = K.getAttribute("data-drag");
      G !== "none" && (Z === null || unref(e.destroyOnClose)) && W(K);
    }
  };
  watchEffect(() => {
    !unref(e.visible) || !unref(e.draggable) || useTimeoutFn(() => {
      H();
    }, 30);
  });
}
function _isSlot(e) {
  return typeof e == "function" || Object.prototype.toString.call(e) === "[object Object]" && !isVNode(e);
}
const Modal = /* @__PURE__ */ defineComponent({
  name: "Modal",
  inheritAttrs: !1,
  components: {
    Modal: Modal$1
  },
  props: basicProps$1,
  emits: ["cancel"],
  setup(e, {
    slots: k,
    emit: W,
    attrs: H
  }) {
    const {
      visible: U,
      draggable: K,
      destroyOnClose: G
    } = toRefs(e);
    useModalDragMove({
      visible: U,
      destroyOnClose: G,
      draggable: K
    });
    const Z = (X) => {
      W("cancel", X);
    };
    return () => {
      let X;
      const Q = {
        ...unref(H),
        ...e,
        onCancel: Z
      };
      return createVNode(Modal$1, Q, _isSlot(X = extendSlots(k)) ? X : {
        default: () => [X]
      });
    };
  }
});
function useWindowSizeFn(e, k = 150, W) {
  let H = () => {
    e();
  };
  H = useDebounceFn(H, k);
  const K = () => {
    W && W.immediate && H(), window.addEventListener("resize", H);
  }, G = () => {
    window.removeEventListener("resize", H);
  };
  return tryOnMounted(() => {
    K();
  }), tryOnUnmounted(() => {
    G();
  }), [K, G];
}
const isServer = typeof window > "u";
function resizeHandler(e) {
  for (const k of e) {
    const W = k.target.__resizeListeners__ || [];
    W.length && W.forEach((H) => {
      H();
    });
  }
}
function addResizeListener(e, k) {
  isServer || (e.__resizeListeners__ || (e.__resizeListeners__ = [], e.__ro__ = new ResizeObserver(resizeHandler), e.__ro__.observe(e)), e.__resizeListeners__.push(k));
}
function removeResizeListener(e, k) {
  !e || !e.__resizeListeners__ || (e.__resizeListeners__.splice(
    e.__resizeListeners__.indexOf(k),
    1
  ), e.__resizeListeners__.length || e.__ro__.disconnect());
}
const BAR_MAP = {
  vertical: {
    offset: "offsetHeight",
    scroll: "scrollTop",
    scrollSize: "scrollHeight",
    size: "height",
    key: "vertical",
    axis: "Y",
    client: "clientY",
    direction: "top"
  },
  horizontal: {
    offset: "offsetWidth",
    scroll: "scrollLeft",
    scrollSize: "scrollWidth",
    size: "width",
    key: "horizontal",
    axis: "X",
    client: "clientX",
    direction: "left"
  }
};
function renderThumbStyle({ move: e, size: k, bar: W }) {
  const H = {}, U = `translate${W.axis}(${e}%)`;
  return H[W.size] = k, H.transform = U, H.msTransform = U, H.webkitTransform = U, H;
}
function extend(e, k) {
  return Object.assign(e, k);
}
function toObject(e) {
  const k = {};
  for (let W = 0; W < e.length; W++)
    e[W] && extend(k, e[W]);
  return k;
}
const Bar = defineComponent({
  name: "Bar",
  props: {
    vertical: Boolean,
    size: String,
    move: Number
  },
  setup(e) {
    const k = getCurrentInstance(), W = ref(), H = inject(
      "scroll-bar-wrap",
      {}
    ), U = computed(() => BAR_MAP[e.vertical ? "vertical" : "horizontal"]), K = ref({}), G = ref(), Z = (oe) => {
      var le, ae;
      if (G.value === !1)
        return;
      const ie = K.value[U.value.axis];
      if (!ie)
        return;
      const ee = (((le = k == null ? void 0 : k.vnode.el) == null ? void 0 : le.getBoundingClientRect()[U.value.direction]) - oe[U.value.client]) * -1, ne = W.value[U.value.offset] - ie, se = (ee - ne) * 100 / ((ae = k == null ? void 0 : k.vnode.el) == null ? void 0 : ae[U.value.offset]);
      H.value[U.value.scroll] = se * H.value[U.value.scrollSize] / 100;
    };
    function X() {
      G.value = !1, K.value[U.value.axis] = 0, off(document, "mousemove", Z), document.onselectstart = null;
    }
    const Q = (oe) => {
      oe.stopImmediatePropagation(), G.value = !0, on(document, "mousemove", Z), on(document, "mouseup", X), document.onselectstart = () => !1;
    }, te = (oe) => {
      var ie;
      oe.ctrlKey || oe.button === 2 || ((ie = window.getSelection()) == null || ie.removeAllRanges(), Q(oe), K.value[U.value.axis] = oe.currentTarget[U.value.offset] - (oe[U.value.client] - oe.currentTarget.getBoundingClientRect()[U.value.direction]));
    }, re = (oe) => {
      var se;
      const ie = Math.abs(
        oe.target.getBoundingClientRect()[U.value.direction] - oe[U.value.client]
      ), ee = W.value[U.value.offset] / 2, ne = (ie - ee) * 100 / ((se = k == null ? void 0 : k.vnode.el) == null ? void 0 : se[U.value.offset]);
      H.value[U.value.scroll] = ne * H.value[U.value.scrollSize] / 100;
    };
    return onUnmounted(() => {
      off(document, "mouseup", X);
    }), () => h$1(
      "div",
      {
        class: ["scrollbar__bar", "is-" + U.value.key],
        onMousedown: re
      },
      h$1("div", {
        ref: W,
        class: "scrollbar__thumb",
        onMousedown: te,
        style: renderThumbStyle({
          size: e.size,
          move: e.move,
          bar: U.value
        })
      })
    );
  }
}), _sfc_main$7 = defineComponent({
  name: "Scrollbar",
  // inheritAttrs: false,
  components: { Bar },
  props: {
    native: {
      type: Boolean,
      default: !1
    },
    wrapStyle: {
      type: [String, Array],
      default: ""
    },
    wrapClass: {
      type: [String, Array],
      default: ""
    },
    viewClass: {
      type: [String, Array],
      default: ""
    },
    viewStyle: {
      type: [String, Array],
      default: ""
    },
    noresize: Boolean,
    // 如果 container 尺寸不会发生变化，最好设置它可以优化性能
    tag: {
      type: String,
      default: "div"
    }
  },
  setup(e) {
    const k = ref("0"), W = ref("0"), H = ref(0), U = ref(0), K = ref(), G = ref();
    provide("scroll-bar-wrap", K);
    const Z = computed(() => Array.isArray(e.wrapStyle) ? toObject(e.wrapStyle) : e.wrapStyle), X = () => {
      e.native || (U.value = unref(K).scrollTop * 100 / unref(K).clientHeight, H.value = unref(K).scrollLeft * 100 / unref(K).clientWidth);
    }, Q = () => {
      if (!unref(K))
        return;
      const te = unref(K).clientHeight * 100 / unref(K).scrollHeight, re = unref(K).clientWidth * 100 / unref(K).scrollWidth;
      W.value = te < 100 ? te + "%" : "", k.value = re < 100 ? re + "%" : "";
    };
    return onMounted(() => {
      e.native || (nextTick(Q), e.noresize || (addResizeListener(unref(G), Q), addResizeListener(unref(K), Q), addEventListener("resize", Q)));
    }), onBeforeUnmount(() => {
      e.native || e.noresize || (removeResizeListener(unref(G), Q), removeResizeListener(unref(K), Q), removeEventListener("resize", Q));
    }), {
      moveX: H,
      moveY: U,
      sizeWidth: k,
      sizeHeight: W,
      style: Z,
      wrap: K,
      resize: G,
      update: Q,
      handleScroll: X
    };
  }
}), Scrollbar_vue_vue_type_style_index_0_lang = "", _hoisted_1$1 = { class: "scrollbar" };
function _sfc_render$7(e, k, W, H, U, K) {
  const G = resolveComponent("bar");
  return openBlock(), createElementBlock("div", _hoisted_1$1, [
    createElementVNode("div", {
      ref: "wrap",
      class: normalizeClass([
        e.wrapClass,
        "scrollbar__wrap",
        e.native ? "" : "scrollbar__wrap--hidden-default"
      ]),
      style: normalizeStyle(e.style),
      onScroll: k[0] || (k[0] = (...Z) => e.handleScroll && e.handleScroll(...Z))
    }, [
      (openBlock(), createBlock(resolveDynamicComponent(e.tag), {
        ref: "resize",
        class: normalizeClass(["scrollbar__view", e.viewClass]),
        style: normalizeStyle(e.viewStyle)
      }, {
        default: withCtx(() => [
          renderSlot(e.$slots, "default")
        ]),
        _: 3
      }, 8, ["class", "style"]))
    ], 38),
    e.native ? createCommentVNode("", !0) : (openBlock(), createElementBlock(Fragment, { key: 0 }, [
      createVNode(G, {
        move: e.moveX,
        size: e.sizeWidth
      }, null, 8, ["move", "size"]),
      createVNode(G, {
        vertical: "",
        move: e.moveY,
        size: e.sizeHeight
      }, null, 8, ["move", "size"])
    ], 64))
  ]);
}
const Scrollbar = /* @__PURE__ */ _export_sfc(_sfc_main$7, [["render", _sfc_render$7]]), easeInOutQuad = (e, k, W, H) => (e /= H / 2, e < 1 ? W / 2 * e * e + k : (e--, -W / 2 * (e * (e - 2) - 1) + k)), move = (e, k) => {
  e.scrollTop = k;
}, position = (e) => e.scrollTop;
function useScrollTo({
  el: e,
  to: k,
  duration: W = 500,
  callback: H
}) {
  const U = ref(!1), K = position(e), G = k - K, Z = 20;
  let X = 0;
  W = isUnDef(W) ? 500 : W;
  const Q = function() {
    if (!unref(U))
      return;
    X += Z;
    const oe = easeInOutQuad(X, K, G, W);
    move(e, oe), X < W && unref(U) ? requestAnimationFrame(Q) : H && isFunction(H) && H();
  };
  return { start: () => {
    U.value = !0, Q();
  }, stop: () => {
    U.value = !1;
  } };
}
const _sfc_main$6 = defineComponent({
  name: `${prefix}ScrollContainer`,
  components: { Scrollbar },
  setup() {
    const e = ref(null);
    function k(U, K = 500) {
      const G = unref(e);
      G && nextTick(() => {
        const Z = unref(G.wrap);
        if (!Z)
          return;
        const { start: X } = useScrollTo({
          el: Z,
          to: U,
          duration: K
        });
        X();
      });
    }
    function W() {
      const U = unref(e);
      return U ? U.wrap : null;
    }
    function H() {
      const U = unref(e);
      U && nextTick(() => {
        const K = unref(U.wrap);
        if (!K)
          return;
        const G = K.scrollHeight, { start: Z } = useScrollTo({
          el: K,
          to: G
        });
        Z();
      });
    }
    return {
      scrollbarRef: e,
      scrollTo: k,
      scrollBottom: H,
      getScrollWrap: W
    };
  }
}), scrollContainer_vue_vue_type_style_index_0_lang = "";
function _sfc_render$6(e, k, W, H, U, K) {
  const G = resolveComponent("Scrollbar");
  return openBlock(), createBlock(G, mergeProps({
    ref: "scrollbarRef",
    class: "scroll-container"
  }, e.$attrs), {
    default: withCtx(() => [
      renderSlot(e.$slots, "default")
    ]),
    _: 3
  }, 16);
}
const ScrollContainer = /* @__PURE__ */ _export_sfc(_sfc_main$6, [["render", _sfc_render$6]]);
ScrollContainer.install = function(e, k) {
  e.component(k || ScrollContainer.name, ScrollContainer);
};
const key = Symbol();
function createModalContext(e) {
  return createContext(e, key);
}
function useModalContext() {
  return useContext(key);
}
const props = {
  loading: { type: Boolean },
  useWrapper: { type: Boolean, default: !0 },
  modalHeaderHeight: { type: Number, default: 57 },
  modalFooterHeight: { type: Number, default: 74 },
  minHeight: { type: Number, default: 200 },
  height: { type: Number },
  footerOffset: { type: Number, default: 0 },
  visible: { type: Boolean },
  fullScreen: { type: Boolean },
  loadingTip: { type: String }
}, _sfc_main$5 = defineComponent({
  name: "ModalWrapper",
  components: { ScrollContainer },
  inheritAttrs: !1,
  props,
  emits: ["height-change", "ext-height"],
  setup(e, { emit: k }) {
    const W = ref(null), H = ref(null), U = ref(0), K = ref(0);
    let G = 0;
    useWindowSizeFn(Q.bind(null, !1)), useMutationObserver(
      H,
      () => {
        Q();
      },
      {
        attributes: !0,
        subtree: !0
      }
    ), createModalContext({
      redoModalHeight: Q
    });
    const Z = computed(() => ({
      minHeight: `${e.minHeight}px`,
      [e.fullScreen ? "height" : "maxHeight"]: `${unref(U)}px`
    }));
    watchEffect(() => {
      e.useWrapper && Q();
    }), watch(
      () => e.fullScreen,
      (te) => {
        Q(), te ? K.value = U.value : U.value = K.value;
      }
    ), onMounted(() => {
      const { modalHeaderHeight: te, modalFooterHeight: re } = e;
      k("ext-height", te + re);
    }), onUnmounted(() => {
    });
    async function X() {
      nextTick(() => {
        var re;
        const te = unref(W);
        te && ((re = te == null ? void 0 : te.scrollTo) == null || re.call(te, 0));
      });
    }
    async function Q() {
      if (!e.visible)
        return;
      const te = unref(W);
      if (!te)
        return;
      const re = te.$el.parentElement;
      if (re) {
        re.style.padding = "0", await nextTick();
        try {
          const oe = re.parentElement && re.parentElement.parentElement;
          if (!oe)
            return;
          const ie = getComputedStyle(oe).top, ee = Number.parseInt(ie);
          let ne = window.innerHeight - ee * 2 + (e.footerOffset || 0) - e.modalFooterHeight - e.modalHeaderHeight;
          ee < 40 && (ne -= 26), await nextTick();
          const se = unref(H);
          if (!se)
            return;
          await nextTick(), G = se.scrollHeight, e.fullScreen ? U.value = window.innerHeight - e.modalFooterHeight - e.modalHeaderHeight - 28 : U.value = e.height ? e.height : G > ne ? ne : G, k("height-change", unref(U));
        } catch (oe) {
          console.log(oe);
        }
      }
    }
    return { wrapperRef: W, spinRef: H, spinStyle: Z, scrollTop: X, setModalHeight: Q };
  }
}), _hoisted_1 = ["loading-tip"];
function _sfc_render$5(e, k, W, H, U, K) {
  const G = resolveComponent("ScrollContainer"), Z = resolveDirective("loading");
  return openBlock(), createBlock(G, { ref: "wrapperRef" }, {
    default: withCtx(() => [
      withDirectives((openBlock(), createElementBlock("div", {
        ref: "spinRef",
        style: normalizeStyle(e.spinStyle),
        "loading-tip": e.loadingTip
      }, [
        renderSlot(e.$slots, "default")
      ], 12, _hoisted_1)), [
        [Z, e.loading]
      ])
    ]),
    _: 3
  }, 512);
}
const ModalWrapper = /* @__PURE__ */ _export_sfc(_sfc_main$5, [["render", _sfc_render$5]]), _sfc_main$4 = defineComponent({
  name: "ModalClose",
  components: {
    Tooltip,
    FullscreenExitOutlined,
    FullscreenOutlined,
    CloseOutlined
  },
  props: {
    canFullscreen: { type: Boolean, default: !0 },
    fullScreen: { type: Boolean }
  },
  emits: ["cancel", "fullscreen"],
  setup(e, { emit: k }) {
    const H = useNamespace("basic-modal-close").b();
    getCurrentInstance();
    const U = useI18n(), K = computed(() => [
      H,
      `${H}--custom`,
      {
        [`${H}--can-full`]: e.canFullscreen
      }
    ]);
    function G(X) {
      k("cancel", X);
    }
    function Z(X) {
      X == null || X.stopPropagation(), X == null || X.preventDefault(), k("fullscreen");
    }
    return {
      t: U,
      getClass: K,
      prefixCls: H,
      handleCancel: G,
      handleFullScreen: Z
    };
  }
}), ModalClose_vue_vue_type_style_index_0_lang = "";
function _sfc_render$4(e, k, W, H, U, K) {
  const G = resolveComponent("FullscreenExitOutlined"), Z = resolveComponent("Tooltip"), X = resolveComponent("FullscreenOutlined"), Q = resolveComponent("CloseOutlined");
  return openBlock(), createElementBlock("div", {
    class: normalizeClass(e.getClass)
  }, [
    e.canFullscreen ? (openBlock(), createElementBlock(Fragment, { key: 0 }, [
      e.fullScreen ? (openBlock(), createBlock(Z, {
        key: 0,
        title: e.t("modal.restore"),
        placement: "bottom"
      }, {
        default: withCtx(() => [
          createVNode(G, {
            role: "full",
            onClick: e.handleFullScreen
          }, null, 8, ["onClick"])
        ]),
        _: 1
      }, 8, ["title"])) : (openBlock(), createBlock(Z, {
        key: 1,
        title: e.t("modal.maximize"),
        placement: "bottom"
      }, {
        default: withCtx(() => [
          createVNode(X, {
            role: "close",
            onClick: e.handleFullScreen
          }, null, 8, ["onClick"])
        ]),
        _: 1
      }, 8, ["title"]))
    ], 64)) : createCommentVNode("", !0),
    createVNode(Z, {
      title: e.t("modal.close"),
      placement: "bottom"
    }, {
      default: withCtx(() => [
        createVNode(Q, { onClick: e.handleCancel }, null, 8, ["onClick"])
      ]),
      _: 1
    }, 8, ["title"])
  ], 2);
}
const ModalClose = /* @__PURE__ */ _export_sfc(_sfc_main$4, [["render", _sfc_render$4]]), _sfc_main$3 = defineComponent({
  name: "BasicModalFooter",
  props: basicProps$1,
  components: {
    Button
  },
  emits: ["ok", "cancel"],
  setup(e, { emit: k }) {
    function W(U) {
      k("ok", U);
    }
    function H(U) {
      k("cancel", U);
    }
    return { handleOk: W, handleCancel: H };
  }
});
function _sfc_render$3(e, k, W, H, U, K) {
  const G = resolveComponent("Button");
  return openBlock(), createElementBlock("div", null, [
    renderSlot(e.$slots, "insertFooter"),
    e.showCancelBtn ? (openBlock(), createBlock(G, mergeProps({ key: 0 }, e.cancelButtonProps, { onClick: e.handleCancel }), {
      default: withCtx(() => [
        createTextVNode(toDisplayString(e.cancelText), 1)
      ]),
      _: 1
    }, 16, ["onClick"])) : createCommentVNode("", !0),
    renderSlot(e.$slots, "centerFooter"),
    e.showOkBtn ? (openBlock(), createBlock(G, mergeProps({
      key: 1,
      type: e.okType,
      onClick: e.handleOk,
      loading: e.confirmLoading
    }, e.okButtonProps), {
      default: withCtx(() => [
        createTextVNode(toDisplayString(e.okText), 1)
      ]),
      _: 1
    }, 16, ["type", "onClick", "loading"])) : createCommentVNode("", !0),
    renderSlot(e.$slots, "appendFooter")
  ]);
}
const ModalFooter = /* @__PURE__ */ _export_sfc(_sfc_main$3, [["render", _sfc_render$3]]), _sfc_main$2 = defineComponent({
  name: "BasicModalHeader",
  components: { BasicTitle: _sfc_main$a },
  props: {
    helpMessage: {
      type: [String, Array]
    },
    title: { type: String }
  },
  emits: ["dblclick"]
});
function _sfc_render$2(e, k, W, H, U, K) {
  const G = resolveComponent("BasicTitle");
  return openBlock(), createBlock(G, { helpMessage: e.helpMessage }, {
    default: withCtx(() => [
      createTextVNode(toDisplayString(e.title), 1)
    ]),
    _: 1
  }, 8, ["helpMessage"]);
}
const ModalHeader = /* @__PURE__ */ _export_sfc(_sfc_main$2, [["render", _sfc_render$2]]);
function useFullScreen(e) {
  const k = ref(!1), W = computed(() => {
    const U = unref(e.wrapClassName) || "";
    return unref(k) ? `fullscreen-modal ${U} ` : unref(U);
  });
  function H(U) {
    U && U.stopPropagation(), k.value = !unref(k);
  }
  return { getWrapClassName: W, handleFullScreen: H, fullScreenRef: k };
}
const _sfc_main$1 = defineComponent({
  name: `${prefix}BasicModal`,
  components: { Modal, ModalWrapper, ModalClose, ModalFooter, ModalHeader },
  inheritAttrs: !1,
  props: basicProps$1,
  emits: [
    "visible-change",
    "height-change",
    "cancel",
    "ok",
    "register",
    "update:visible"
  ],
  setup(e, { emit: k, attrs: W }) {
    const H = ref(!1), U = ref(null), K = ref(null), G = useNamespace("basic-modal"), Z = ref(0), X = {
      setModalProps: ae,
      emitVisible: void 0,
      redoModalHeight: () => {
        nextTick(() => {
          unref(K) && unref(K).setModalHeight();
        });
      }
    }, Q = getCurrentInstance();
    Q && k("register", X, Q.uid);
    const te = computed(() => ({
      ...e,
      ...unref(U)
    })), { handleFullScreen: re, getWrapClassName: oe, fullScreenRef: ie } = useFullScreen(
      {
        modalWrapperRef: K,
        extHeightRef: Z,
        wrapClassName: toRef(te.value, "wrapClassName")
      }
    ), ee = computed(() => ({
      ...{
        ...unref(te),
        visible: unref(H),
        okButtonProps: void 0,
        cancelButtonProps: void 0,
        title: void 0
      },
      wrapClassName: unref(oe)
    })), ne = computed(() => {
      const ce = {
        ...W,
        ...unref(te),
        visible: unref(H),
        wrapClassName: unref(oe)
      };
      return unref(ie) ? omit(ce, ["height", "title"]) : omit(ce, "title");
    }), se = computed(() => {
      if (!unref(ie))
        return unref(ee).height;
    });
    watchEffect(() => {
      H.value = !!e.visible, ie.value = !!e.defaultFullscreen;
    }), watch(
      () => unref(H),
      (ce) => {
        k("visible-change", ce), k("update:visible", ce), nextTick(() => {
          e.scrollTop && ce && unref(K) && unref(K).scrollTop();
        });
      },
      {
        immediate: !1
      }
    );
    async function le(ce) {
      var me, ve;
      if (ce == null || ce.stopPropagation(), !((ve = (me = ce.target) == null ? void 0 : me.classList) != null && ve.contains(
        G.b() + "-close--custom"
      ))) {
        if (e.closeFunc && isFunction(e.closeFunc)) {
          const we = await e.closeFunc();
          H.value = !we;
          return;
        }
        H.value = !1, k("cancel", ce);
      }
    }
    function ae(ce) {
      U.value = deepMerge(unref(U) || {}, ce), Reflect.has(ce, "visible") && (H.value = !!ce.visible), Reflect.has(ce, "defaultFullscreen") && (ie.value = !!ce.defaultFullscreen);
    }
    function de(ce) {
      k("ok", ce);
    }
    function ue(ce) {
      k("height-change", ce);
    }
    function fe(ce) {
      Z.value = ce;
    }
    function ge(ce) {
      e.canFullscreen && (ce.stopPropagation(), re(ce));
    }
    return {
      handleCancel: le,
      getBindValue: ne,
      getProps: ee,
      handleFullScreen: re,
      fullScreenRef: ie,
      getMergeProps: te,
      handleOk: de,
      visibleRef: H,
      omit,
      modalWrapperRef: K,
      handleExtHeight: fe,
      handleHeightChange: ue,
      handleTitleDbClick: ge,
      getWrapperHeight: se
    };
  }
});
function _sfc_render$1(e, k, W, H, U, K) {
  const G = resolveComponent("ModalClose"), Z = resolveComponent("ModalHeader"), X = resolveComponent("ModalFooter"), Q = resolveComponent("ModalWrapper"), te = resolveComponent("Modal", !0);
  return openBlock(), createBlock(te, mergeProps(e.getBindValue, { onCancel: e.handleCancel }), createSlots({
    default: withCtx(() => [
      createVNode(Q, mergeProps(
        {
          useWrapper: e.getProps.useWrapper,
          footerOffset: e.wrapperFooterOffset,
          fullScreen: e.fullScreenRef,
          ref: "modalWrapperRef",
          loading: e.getProps.loading,
          "loading-tip": e.getProps.loadingTip,
          minHeight: e.getProps.minHeight,
          height: e.getWrapperHeight,
          visible: e.visibleRef,
          modalFooterHeight: e.footer !== void 0 && !e.footer ? 0 : void 0
        },
        e.omit(e.getProps.wrapperProps, "visible", "height", "modalFooterHeight"),
        {
          onExtHeight: e.handleExtHeight,
          onHeightChange: e.handleHeightChange
        }
      ), {
        default: withCtx(() => [
          renderSlot(e.$slots, "default")
        ]),
        _: 3
      }, 16, ["useWrapper", "footerOffset", "fullScreen", "loading", "loading-tip", "minHeight", "height", "visible", "modalFooterHeight", "onExtHeight", "onHeightChange"])
    ]),
    _: 2
  }, [
    e.$slots.closeIcon ? void 0 : {
      name: "closeIcon",
      fn: withCtx(() => [
        createVNode(G, {
          canFullscreen: e.getProps.canFullscreen,
          fullScreen: e.fullScreenRef,
          onCancel: e.handleCancel,
          onFullscreen: e.handleFullScreen
        }, null, 8, ["canFullscreen", "fullScreen", "onCancel", "onFullscreen"])
      ]),
      key: "0"
    },
    e.$slots.title ? void 0 : {
      name: "title",
      fn: withCtx(() => [
        createVNode(Z, {
          helpMessage: e.getProps.helpMessage,
          title: e.getMergeProps.title,
          onDblclick: e.handleTitleDbClick
        }, null, 8, ["helpMessage", "title", "onDblclick"])
      ]),
      key: "1"
    },
    e.$slots.footer ? void 0 : {
      name: "footer",
      fn: withCtx(() => [
        createVNode(X, mergeProps(e.getBindValue, {
          onOk: e.handleOk,
          onCancel: e.handleCancel
        }), createSlots({ _: 2 }, [
          renderList(Object.keys(e.$slots), (re) => ({
            name: re,
            fn: withCtx((oe) => [
              renderSlot(e.$slots, re, normalizeProps(guardReactiveProps(oe || {})))
            ])
          }))
        ]), 1040, ["onOk", "onCancel"])
      ]),
      key: "2"
    },
    renderList(Object.keys(e.omit(e.$slots, "default")), (re) => ({
      name: re,
      fn: withCtx((oe) => [
        renderSlot(e.$slots, re, normalizeProps(guardReactiveProps(oe || {})))
      ])
    }))
  ]), 1040, ["onCancel"]);
}
const BasicModal = /* @__PURE__ */ _export_sfc(_sfc_main$1, [["render", _sfc_render$1]]), modal = "";
reactive({});
reactive({});
BasicModal.install = function(e, k) {
  e.component(k || BasicModal.name, BasicModal);
};
const basicProps = {
  model: {
    type: Object,
    default: {}
  },
  // 标签宽度  固定宽度
  labelWidth: {
    type: [Number, String],
    default: 0
  },
  fieldMapToTime: {
    type: Array,
    default: () => []
  },
  compact: propTypes.bool,
  // 表单配置规则
  schemas: {
    type: [Array],
    default: () => []
  },
  mergeDynamicData: {
    type: Object,
    default: null
  },
  baseRowStyle: {
    type: Object
  },
  baseColProps: {
    type: Object
  },
  autoSetPlaceHolder: propTypes.bool.def(!0),
  // 在INPUT组件上单击回车时，是否自动提交
  autoSubmitOnEnter: propTypes.bool.def(!1),
  submitOnReset: propTypes.bool,
  submitOnChange: propTypes.bool,
  size: propTypes.oneOf(["default", "small", "large"]).def("default"),
  // 禁用表单
  disabled: propTypes.bool,
  emptySpan: {
    type: [Number, Object],
    default: 0
  },
  // 是否显示收起展开按钮
  showAdvancedButton: propTypes.bool,
  // 转化时间
  transformDateFunc: {
    type: Function,
    default: (e) => {
      var k;
      return ((k = e == null ? void 0 : e.format) == null ? void 0 : k.call(e, "YYYY-MM-DD HH:mm:ss")) ?? e;
    }
  },
  rulesMessageJoinLabel: propTypes.bool.def(!0),
  // 超过3行自动折叠
  autoAdvancedLine: propTypes.number.def(3),
  // 不受折叠影响的行数
  alwaysShowLines: propTypes.number.def(1),
  // 是否显示操作按钮
  showActionButtonGroup: propTypes.bool.def(!0),
  // 操作列Col配置
  actionColOptions: Object,
  // 显示重置按钮
  showResetButton: propTypes.bool.def(!0),
  // 是否聚焦第一个输入框，只在第一个表单项为input的时候作用
  autoFocusFirstItem: propTypes.bool,
  // 重置按钮配置
  resetButtonOptions: Object,
  // 显示确认按钮
  showSubmitButton: propTypes.bool.def(!0),
  // 确认按钮配置
  submitButtonOptions: Object,
  // 自定义重置函数
  resetFunc: Function,
  submitFunc: Function,
  // 以下为默认props
  hideRequiredMark: propTypes.bool,
  labelCol: Object,
  layout: propTypes.oneOf(["horizontal", "vertical", "inline"]).def("horizontal"),
  tableAction: {
    type: Object
    // as PropType<TableActionType>
  },
  wrapperCol: Object,
  colon: propTypes.bool,
  labelAlign: propTypes.string,
  rowProps: Object
}, _sfc_main = defineComponent({
  name: "BasicForm",
  components: { FormItem: _sfc_main$9, Form, Row, FormAction },
  props: basicProps,
  emits: [
    "advanced-change",
    "reset",
    "submit",
    "register",
    "field-value-change"
  ],
  setup(e, { emit: k, attrs: W }) {
    const H = reactive({}), U = useModalContext(), K = reactive({
      isAdvanced: !0,
      hideAdvanceBtn: !1,
      isLoad: !1,
      actionSpan: 6
    }), G = ref({}), Z = ref(!1), X = ref({}), Q = ref(null), te = ref(null), re = useNamespace("basic-form"), oe = computed(() => ({ ...e, ...unref(X) })), ie = computed(() => [
      re,
      {
        [`${re}--compact`]: unref(oe).compact
      }
    ]), ee = computed(() => {
      const { baseRowStyle: pe = {}, rowProps: be } = unref(oe);
      return {
        style: pe,
        ...be
      };
    }), ne = computed(
      () => ({ ...W, ...e, ...unref(oe) })
    ), se = computed(() => {
      const pe = unref(Q) || unref(oe).schemas;
      for (const be of pe) {
        const { defaultValue: Se, component: Oe } = be;
        if (Se && dateItemType.includes(Oe))
          if (!Array.isArray(Se))
            be.defaultValue = dateUtil(Se);
          else {
            const Ae = [];
            Se.forEach((Pe) => {
              Ae.push(dateUtil(Pe));
            }), be.defaultValue = Ae;
          }
      }
      return unref(oe).showAdvancedButton ? pe.filter(
        (be) => be.component !== "Divider"
      ) : pe;
    }), { handleToggleAdvanced: le } = useAdvanced({
      advanceState: K,
      emit: k,
      getProps: oe,
      getSchema: se,
      formModel: H,
      defaultValueRef: G
    }), { handleFormValues: ae, initDefault: de } = useFormValues({
      getProps: oe,
      defaultValueRef: G,
      getSchema: se,
      formModel: H
    });
    useAutoFocus({
      getSchema: se,
      getProps: oe,
      isInitedDefault: Z,
      formElRef: te
    });
    const {
      handleSubmit: ue,
      setFieldsValue: fe,
      clearValidate: ge,
      validate: ce,
      validateFields: me,
      getFieldsValue: ve,
      updateSchema: we,
      resetSchema: Ce,
      appendSchemaByField: Te,
      removeSchemaByFiled: ye,
      resetFields: he,
      scrollToField: _e
    } = useFormEvents({
      emit: k,
      getProps: oe,
      formModel: H,
      getSchema: se,
      defaultValueRef: G,
      formElRef: te,
      schemaRef: Q,
      handleFormValues: ae
    });
    createFormContext({
      resetAction: he,
      submitAction: ue
    }), watch(
      () => unref(oe).model,
      () => {
        const { model: pe } = unref(oe);
        pe && fe(pe);
      },
      {
        immediate: !0
      }
    ), watch(
      () => unref(oe).schemas,
      (pe) => {
        Ce(pe ?? []);
      }
    ), watch(
      () => se.value,
      (pe) => {
        nextTick(() => {
          var be;
          (be = U == null ? void 0 : U.redoModalHeight) == null || be.call(U);
        }), !unref(Z) && pe != null && pe.length && (de(), Z.value = !0);
      }
    ), watch(
      () => H,
      useDebounceFn(() => {
        unref(oe).submitOnChange && ue();
      }, 300),
      { deep: !0 }
    );
    async function $e(pe) {
      X.value = deepMergeObject(unref(X) || {}, pe);
    }
    function Fe(pe, be) {
      H[pe] = be;
      const { validateTrigger: Se } = unref(ne);
      (!Se || Se === "change") && me([pe]).catch((Oe) => {
      }), k("field-value-change", pe, be);
    }
    function ke(pe) {
      const { autoSubmitOnEnter: be } = unref(oe);
      if (be && pe.key === "Enter" && pe.target && pe.target instanceof HTMLElement) {
        const Se = pe.target;
        Se && Se.tagName && Se.tagName.toUpperCase() == "INPUT" && ue();
      }
    }
    const Be = {
      getFieldsValue: ve,
      setFieldsValue: fe,
      resetFields: he,
      updateSchema: we,
      resetSchema: Ce,
      setProps: $e,
      removeSchemaByFiled: ye,
      appendSchemaByField: Te,
      clearValidate: ge,
      validateFields: me,
      validate: ce,
      submit: ue,
      scrollToField: _e
    };
    return onMounted(() => {
      de(), k("register", Be);
    }), {
      getBindValue: ne,
      handleToggleAdvanced: le,
      handleEnterPress: ke,
      formModel: H,
      defaultValueRef: G,
      advanceState: K,
      getRow: ee,
      getProps: oe,
      formElRef: te,
      getSchema: se,
      formActionType: Be,
      setFormModel: Fe,
      getFormClass: ie,
      getFormActionBindProps: computed(
        () => ({ ...oe.value, ...K })
      ),
      ...Be
    };
  }
}), BasicForm_vue_vue_type_style_index_0_lang = "";
function _sfc_render(e, k, W, H, U, K) {
  const G = resolveComponent("FormItem"), Z = resolveComponent("FormAction"), X = resolveComponent("Row"), Q = resolveComponent("Form");
  return openBlock(), createBlock(Q, mergeProps(e.getBindValue, {
    class: e.getFormClass,
    ref: "formElRef",
    model: e.formModel,
    onKeypress: withKeys(e.handleEnterPress, ["enter"])
  }), {
    default: withCtx(() => [
      createVNode(X, normalizeProps(guardReactiveProps(e.getRow)), {
        default: withCtx(() => [
          renderSlot(e.$slots, "formHeader"),
          (openBlock(!0), createElementBlock(Fragment, null, renderList(e.getSchema, (te) => (openBlock(), createBlock(G, {
            key: te.field,
            tableAction: e.tableAction,
            formActionType: e.formActionType,
            schema: te,
            formProps: e.getProps,
            allDefaultValues: e.defaultValueRef,
            formModel: e.formModel,
            setFormModel: e.setFormModel
          }, createSlots({ _: 2 }, [
            renderList(Object.keys(e.$slots), (re) => ({
              name: re,
              fn: withCtx((oe) => [
                renderSlot(e.$slots, re, normalizeProps(guardReactiveProps(oe || {})))
              ])
            }))
          ]), 1032, ["tableAction", "formActionType", "schema", "formProps", "allDefaultValues", "formModel", "setFormModel"]))), 128)),
          createVNode(Z, mergeProps(e.getFormActionBindProps, { onToggleAdvanced: e.handleToggleAdvanced }), createSlots({ _: 2 }, [
            renderList([
              "resetBefore",
              "submitBefore",
              "advanceBefore",
              "advanceAfter"
            ], (te) => ({
              name: te,
              fn: withCtx((re) => [
                renderSlot(e.$slots, te, normalizeProps(guardReactiveProps(re || {})))
              ])
            }))
          ]), 1040, ["onToggleAdvanced"]),
          renderSlot(e.$slots, "formFooter")
        ]),
        _: 3
      }, 16)
    ]),
    _: 3
  }, 16, ["class", "model", "onKeypress"]);
}
const BasicForm = /* @__PURE__ */ _export_sfc(_sfc_main, [["render", _sfc_render]]);
BasicForm.install = function(e, k) {
  e.component(BasicForm.name || k, BasicForm);
};
const index = {
  title: "BasicForm  表单",
  category: "高级组件",
  status: "100%",
  install(e) {
    e.component(BasicForm.name, BasicForm);
  }
};
export {
  ApiCascader,
  ApiRadioGroup,
  ApiSearch,
  ApiSelect,
  ApiSelectHighlight,
  ApiTree,
  ApiTreeSelect,
  BasicForm,
  RadioButtonGroup,
  index as default,
  useComponentRegister,
  useForm
};
